#ifndef _SI47XX_H_
#define _SI47XX_H_

/*ͷļ*/
#include "stm32g4xx.h"


typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;


/*** ע uint_8ִгɹ񷵻ֵ01  u8ֵͳɹ޹أ***/

#define si47xx_SLAVE_ADDRESS  0x22      //дַ

/*STATUS bits*/ 
#define STCINT  							0x01
#define ASQINT 								0x02
#define RDSINT  							0x04
#define RSQINT  							0x08
#define ERR     							0x40
#define CTS     							0x80

/*POWER_UP*/ 
#define POWER_UP                     	 	0x01
#define POWER_UP_IN_FUNC_FMRX         		0x00
#define POWER_UP_IN_FUNC_AMRX         		0x01
#define POWER_UP_IN_FUNC_FMTX         		0x02
#define POWER_UP_IN_FUNC_WBRX         		0x03
#define POWER_UP_IN_FUNC_QUERY        		0x0F
#define POWER_UP_IN_PATCH             		0x20
#define POWER_UP_IN_GPO2OEN           		0x40
#define POWER_UP_IN_CTSIEN            		0x80
#define POWER_UP_IN_OPMODE_RX_ANALOG  		0x05
#define POWER_UP_IN_OPMODE_TX_ANALOG  		0x50

/*GET_REV*/ 
#define GET_REV 0x10

/*POWER_DOWN*/  
#define POWER_DOWN 0x11

/*SET_PROPERTY*/  
#define SET_PROPERTY 0x12

/*GET_PROPERTY*/
#define GET_PROPERTY 0x13

/*GET_INT_STATUS*/
#define GET_INT_STATUS 0x14

// FM_TUNE_FREQ
#define FM_TUNE_FREQ 0x20

/*FM_SEEK_START*/ 
#define FM_SEEK_START           			0x21
#define FM_SEEK_START_IN_WRAP   			0x04
#define FM_SEEK_START_IN_SEEKUP 			0x08

/*FM_TUNE_STATUS*/ 
#define FM_TUNE_STATUS           			0x22
#define FM_TUNE_STATUS_IN_INTACK 			0x01
#define FM_TUNE_STATUS_IN_CANCEL 			0x02
#define FM_TUNE_STATUS_OUT_VALID 			0x01
#define FM_TUNE_STATUS_OUT_AFCRL 			0x02
#define FM_TUNE_STATUS_OUT_BLTF  			0x80

/*FM_RSQ_STATUS*/ 
#define FM_RSQ_STATUS              			0x23
#define FM_RSQ_STATUS_IN_INTACK    			0x01
#define FM_RSQ_STATUS_OUT_RSSILINT 			0x01
#define FM_RSQ_STATUS_OUT_RSSIHINT 			0x02
#define FM_RSQ_STATUS_OUT_ASNRLINT 			0x04
#define FM_RSQ_STATUS_OUT_ASNRHINT 			0x08
#define FM_RSQ_STATUS_OUT_BLENDINT 			0x80
#define FM_RSQ_STATUS_OUT_VALID    			0x01
#define FM_RSQ_STATUS_OUT_AFCRL    			0x02
#define FM_RSQ_STATUS_OUT_SMUTE    			0x08
#define FM_RSQ_STATUS_OUT_PILOT    			0x80
#define FM_RSQ_STATUS_OUT_STBLEND  			0x7F

/*FM_RDS_STATUS*/ 
#define FM_RDS_STATUS               		0x24
#define FM_RDS_STATUS_IN_INTACK    			0x01
#define FM_RDS_STATUS_IN_MTFIFO     		0x02
#define FM_RDS_STATUS_OUT_RECV      		0x01
#define FM_RDS_STATUS_OUT_SYNCLOST  		0x02
#define FM_RDS_STATUS_OUT_SYNCFOUND 		0x04
#define FM_RDS_STATUS_OUT_SYNC      		0x01
#define FM_RDS_STATUS_OUT_GRPLOST   		0x04
#define FM_RDS_STATUS_OUT_BLED      		0x03
#define FM_RDS_STATUS_OUT_BLEC      		0x0C
#define FM_RDS_STATUS_OUT_BLEB      		0x30
#define FM_RDS_STATUS_OUT_BLEA      		0xC0
#define FM_RDS_STATUS_OUT_BLED_SHFT 		0
#define FM_RDS_STATUS_OUT_BLEC_SHFT 		2
#define FM_RDS_STATUS_OUT_BLEB_SHFT 		4
#define FM_RDS_STATUS_OUT_BLEA_SHFT 		6

/*FM_AGC_STATUS*/
#define FM_AGC_STATUS               		0x27
#define FM_AGC_STATUS_READ_RFAGCDIS 		0x01
#define FM_AGC_STATUS_READ_LNA_GAIN_INDEX   0x1F

/*FM_AGC_OVERRIDE*/
#define FM_AGC_OVERRIDE               		0x28

/*FM Properties*/
#define GPO_IEN               				0x0001
#define GPO_IEN_CTSIEN               		0x0080 //
#define GPO_IEN_CTSIDIS               		0xFF7F //
#define GPO_IEN_RSQIEN               		0x0008 //
#define GPO_IEN_RSQIDIS              		0xFFF7 //
#define DIGITAL_OUTPUT_FORMAT              	0x0102
#define DIGITAL_OUTPUT_SAMPLE_RATE          0x0104
#define REFCLK_FREQ               			0x0201
#define REFCLK_PRESCALE               		0x0202
#define FM_DEEMPHASIS               		0x1100
#define FM_CHANNEL_FILTER               	0x1102
#define FM_BLEND_STEREO_THRESHOLD         	0x1105
#define FM_BLEND_MONO_THRESHOLD            	0x1106
#define FM_ANTENNA_INPUT               		0x1107
#define FM_MAX_TUNE_ERROR              		0x1108
#define FM_RSQ_INT_SOURCE              		0x1200
#define FM_RSQ_INT_SOURCE_BLENDIEN         	0x0080
#define FM_RSQ_INT_SOURCE_BLENDIDIS        	0xFF7F
#define FM_RSQ_INT_SOURCE_MULTHIEN         	0x0020
#define FM_RSQ_INT_SOURCE_MULTHIDIS        	0xFFDF
#define FM_RSQ_INT_SOURCE_MULTLIEN        	0x0010
#define FM_RSQ_INT_SOURCE_MULTLIDIS     	0xFFEF
#define FM_RSQ_INT_SOURCE_SNRHIEN          	0x0008
#define FM_RSQ_INT_SOURCE_SNRHIDIS          0xFFF7
#define FM_RSQ_INT_SOURCE_SNRLIEN           0x0004
#define FM_RSQ_INT_SOURCE_SNRLIDIS         	0xFFFB
#define FM_RSQ_INT_SOURCE_RSSIHIEN          0x0002
#define FM_RSQ_INT_SOURCE_RSSIHIDIS         0xFFFD
#define FM_RSQ_INT_SOURCE_RSSILIEN         	0x0001
#define FM_RSQ_INT_SOURCE_RSSILIDIS        	0xFFFE
#define FM_RSQ_SNR_HI_THRESHOLD             0x1201
#define FM_RSQ_SNR_LO_THRESHOLD             0x1202
#define FM_RSQ_RSSI_HI_THRESHOLD            0x1203
#define FM_RSQ_RSSI_LO_THRESHOLD            0x1204
#define FM_RSQ_MULTIPATH_HI_THRESHOLD       0x1205
#define FM_RSQ_MULTIPATH_LO_THRESHOLD       0x1206
#define FM_RSQ_BLEND_THRESHOLD              0x1207
#define FM_SOFT_MUTE_RATE               	0x1300
#define FM_SOFT_MUTE_MAX_ATTENUATION        0x1302
#define FM_SOFT_MUTE_SNR_THRESHOLD          0x1303
#define FM_SEEK_BAND_BOTTOM                	0x1400
#define FM_SEEK_BAND_TOP                	0x1401
#define FM_SEEK_FREQ_SPACING                0x1402
#define FM_SEEK_TUNE_SNR_THRESHOLD          0x1403
#define FM_SEEK_TUNE_RSSI_THRESHOLD         0x1404
#define FM_BLEND_RSSI_STEREO_THRESHOLD      0x1800
#define FM_BLEND_RSSI_MONO_THRESHOLD        0x1801
#define FM_BLEND_RSSI_ATTACK_RATE           0x1802
#define FM_BLEND_RSSI_RELEASE_RATE          0x1803
#define FM_BLEND_SNR_STEREO_THRESHOLD       0x1804
#define FM_BLEND_SNR_MONO_THRESHOLD         0x1805
#define FM_BLEND_SNR_ATTACK_RATE            0x1806
#define FM_BLEND_SNR_RELEASE_RATE           0x1807
#define FM_BLEND_MULTIPATH_STEREO_THRESHOLD 0x1808
#define FM_BLEND_MULTIPATH_MONO_THRESHOLD   0x1809
#define FM_BLEND_MULTIPATH_ATTACK_RATE      0x180A
#define FM_BLEND_MULTIPATH_RELEASE_RATE     0x180B
#define RX_VOLUME                			0x4000
#define RX_VOLUME_VOL_MAX                	63
#define RX_VOLUME_VOL_MIN                	0
#define RX_HARD_MUTE                		0x4001
#define RF_AGC_ATTACK_RATE                	0x4100
#define RF_AGC_RELEASE_RATE                 0x4101

/*峣*/
#define ON  0
#define OFF 1
#define NUM_SEEK_PRESETS 30

/*SI47XX reset */
#define si47xx_RESET_PORT    	GPIOA			        //GPIO˿ 
#define si47xx_RESET_CLK 	    RCC_APB2Periph_GPIOA	//GPIO˿ʱ
#define si47xx_RESET_PIN		GPIO_PIN_7			       
#define si47xx_RESET_H	HAL_GPIO_WritePin(si47xx_RESET_PORT, si47xx_RESET_PIN, 1)
#define si47xx_RESET_L	HAL_GPIO_WritePin(si47xx_RESET_PORT, si47xx_RESET_PIN, 0)

/**/
typedef struct
{
	float seek_preset_freq[NUM_SEEK_PRESETS];  			//FMģƵϢ
	uint8_t seek_preset_rssi[NUM_SEEK_PRESETS];     	//FMģƵζӦRSSI
	uint8_t seek_fm_num;                                //FMģƵ
} fm_freq_st;                    						//FMƵʶϢṹ

typedef struct
{
   	u8   stc;       									//(ѡ)seek/tuneɱ־λ
	u8   bltf;											//(ѡ)Ƶɨ赽߽־λ
	u8   afcrl;											//(ѡ)
	u8   valid; 										//(ѡ)Чλ
	float  freq;   										//ǰƵ
	u8   rssi;  										//RSSI
	u8   asnr;											//
	u16  antcap;          								//(ѡ)Э
} fm_tune_status_st;                    				//FM tune״̬Ϣṹ

typedef struct
{
	u8   blend_int;
	u8   snrh_int;
	u8   snrl_int;
	u8   rssih_int;
	u8   rssil_int;
	u8   smute;
	u8   afcrl;
	u8   valid;
	u8   pilot;
	u8   stblend;
	u8   rssi;
	u8   asnr;
	u8   freq_off;
} fm_rsq_status_st;                    					//ѡFM rsq״̬Ϣṹ

extern fm_rsq_status_st fm_rsq_status;					//fm_rsq_status
extern fm_tune_status_st fm_tune_status;				//fm_tune_status
extern fm_freq_st fm_freq;								//fm_freq

extern u8 rf_agc_status;								//AGC״̬Ϣ
extern u8 lna_gain_index;
extern u8	power_up;									//ϵ״ָ̬ʾλ
extern u8 	WaitSTCInterrupt;
extern u8 	SeekTuneInProc;
extern u8  cmd[8];										//Ϣ洢buf
extern u8  rsp[13];										//ظϢ洢buf
extern u8  status;   									//ָʾFMģǷ
extern u8  autoseek_flag;

/*ײӿ*/
void si47xx_RESETGPIO_Config(void);										  //λIOڳʼ
uint8_t si47xx_SendCmd(u8 *_pCmdBuf, u8 _ucCmdLen);						  //ָ
static void Delay(void);												  //ӳ
uint8_t si47xx_WriteReg(u8 *_pCmdBuf, u8 _ucCmdLen);					  //Ĵָ
void si47xx_ReadData(u8 num, u8 *Read);									  //ȡָ
u8 si47xx_readStatus(void);												  //ȡǰ״̬
uint8_t si47xx_waitForCTS(void);										  //ȴджϱ־
uint8_t si47xx_command(u8 cmd_size, u8 *cmd, u8 reply_size, u8 *reply);	  //ֵ
static uint8_t fmTuneFreq(float frequency);								  //FM_TUNE_FREQ
u8 getIntStatus(void);													  //ȡж״̬
uint8_t fmAgcStatus(void);												  //ȡFM_AGC_STATUS
uint8_t fmAgcOverride(u8 rfagcdis, u8 lna_gain_index);					  //FM_AGC_OVERRIDE
uint8_t fmTuneStatus(u8 cancel, u8 intack);								  //ȡFM_TUNE_STATUS
uint8_t fmRsqStatus(u8 intack);											  //ȡFM_RSQ_STATUS
u8 si47xxFMRX_tune(float frequency);									  //FMƵ
static void insert_preset(float frequency, u8 rssi, u8 *seek_preset_rssi);//ɨ赽ĵ̨Ϣṹ
u8 si47xxFMRX_get_rssi(void);											  //ȡFMƵʵrssi
float si47xxFMRX_get_frequency(void);									  //ȡFMƵ
static uint8_t fmSeekStart(u8 seekUp, u8 wrap);		  					  //FMƵɨ
u8 si47xxFMRX_seek(u8 seekup, u8 seekmode);								  //FMƵɨģʽ
uint8_t si47xxFMRX_autoseek(void);										  //ԶɨFM̨Ϣ
uint8_t si47xx_PowerUp(void);											  //FMģϵ
void si47xx_Reset(void);												  //ģ鸴λ
u16 si47xx_WaitStatus80(u32 _uiTimeOut, u8 _ucStopEn);					  //ȴ

/*ûúӿ*/
void LogFmTuneStatus(void);                								  //ӡFM״̬Ϣ
void si47xx_Init(void);													  //FMģʼ
uint8_t si47xx_SetFMFreq(float _uiFreq);								  //FMǰƵ
uint8_t si47xx_ScanUpdateFMFreq(void);									  //FMƵɨϴ
uint8_t si47xx_GetRadioStatus(void);									  //ȡǰFM״̬Ϣ
uint8_t si47xx_SetProperty(uint16_t _usPropNumber, uint16_t _usPropValue);//ģ
uint8_t si47xx_GetProperty(uint16_t _usPropNumber,uint8_t *_ReadBuf);	  //ȡģָϢ
uint8_t si47xx_GetRevision(uint8_t *_ReadBuf);							  //ȡ汾Ϣ
uint8_t si47xx_MonitorRSQSet(u16 rsq_int_source,u16 rsq_int_source_value);//üźϢRSQ
uint8_t si47xx_FMRsqStatusMoniter(void);								  //ȡźżźϢRSQ
uint8_t si47xx_PowerDown(void);											  //FMģϵ
uint8_t si47xx_SoftMuteSet(u16 value1,u16 value2,u16 value3);			  //

#endif

