/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	si47xx.c
	*
	*	ߣ 		
	*
	*	ڣ 		2018-9-21
	*
	*	汾 		V1.0
	*
	*	˵ 		si4734  FMģ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/
/*ͷļ*/
#include "si47xx.h"
#include "fm_rtc_i2c.h"
#include "usart.h"
//Ͷ
#include "typedef.h"
#include "system_task.h"

#undef  LOG_TAG
#define LOG_TAG    "si47xx"
#include <elog.h>


/*TUNE_STATUSر*/
fm_tune_status_st fm_tune_status;

/*RSQ_STATUSر*/
fm_rsq_status_st fm_rsq_status;

/*AGC_STATUSر*/
u8 rf_agc_status;
u8 lna_gain_index;

/*ƵϢ*/
fm_freq_st fm_freq;

/*״̬ͻظbuf*/
u8	power_up=0;
u8 	WaitSTCInterrupt = 0;
u8 	SeekTuneInProc = 0;
u8  cmd[8];
u8  rsp[13];
u8  status;
u8  autoseek_flag=0;

/*
************************************************************
*	ƣ	si47xx_RESETGPIO_Config
*
*	ܣ	λ
*
*	ڲ	
*
*	ز	
*
*	˵ PB0--RESET
************************************************************
*/
void si47xx_RESETGPIO_Config(void)
{		
	GPIO_InitTypeDef GPIO_InitStructure;       			//һGPIO_InitTypeDef͵Ľṹ

	RCC_APB2PeriphClockCmd( si47xx_RESET_CLK, ENABLE);	//LEDصGPIOʱ

	GPIO_InitStructure.GPIO_Pin = si47xx_RESET_PIN;		//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 	//ģʽΪͨ 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 	//Ϊ50MHz	

	GPIO_Init(si47xx_RESET_PORT, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
}

/*
************************************************************
*	ƣ	si47xx_SendCmd
*
*	ܣ	ģ鷢
*
*	ڲ	_pCmdBuf  _ucCmdLenֽ 
*
*	ز	0дʧ  1дɹ
*
*	˵
************************************************************
*/
uint8_t si47xx_SendCmd(u8 *_pCmdBuf, u8 _ucCmdLen)
{
	u8 ack;
	u8 i;

	Si47xx_IIC_Start();
	ack = Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS);
	if (ack != 0)
	{
		goto err;
	}
	for (i = 0; i < _ucCmdLen; i++)
	{
		ack = Si47xx_IIC_SendByte(_pCmdBuf[i]);
		if (ack != 0)
		{
			goto err;
		}
	}
	Si47xx_IIC_Stop();
	return 1;

err:
	Si47xx_IIC_Stop();
	return 0;
}

/*
************************************************************
*	ƣ	Delay
*
*	ܣ	ӳ
*
*	ڲ	 
*
*	ز	
*
*	˵
************************************************************
*/
static void Delay(void)
{
	int i=0,j=0;
	
	for(i=0;i<1000;i++)
	{
		for(j=0;j<1000;j++)
		{;}
	}
}

/*
************************************************************
*	ƣ	si47xx_WriteReg
*
*	ܣ	ģĴд
*
*	ڲ	_pCmdBuf  _ucCmdLenֽ 
*
*	ز	0дʧ  1дɹ
*
*	˵
************************************************************
*/
uint8_t si47xx_WriteReg(u8 *_pCmdBuf, u8 _ucCmdLen)
{
	uint8_t ack;
	uint8_t i;

	Si47xx_IIC_Start();
	ack = Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS);
	if (ack != 0)
	{
		goto err;
	}
	for (i = 0; i < _ucCmdLen; i++)
	{
		ack = Si47xx_IIC_SendByte(_pCmdBuf[i]);
		if (ack != 0)
		{
			goto err;
		}
	}
	Si47xx_IIC_Stop();
	return 1;

err:
	Si47xx_IIC_Stop();
	return 0;
}

/*
************************************************************
*	ƣ	si47xx_ReadData
*
*	ܣ	ȡֵ
*
*	ڲ	numֽ  Read洢buf
*
*	ز	
*
*	˵
************************************************************
*/
void si47xx_ReadData(u8 num, u8 *Read)
{
	unsigned char i;

	Si47xx_IIC_Start();
	Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS+1);
	for(i=0;i<(num-1);i++)
	{
		Read[i] = Si47xx_IIC_RecvByte(ACK);
	}
	*Read=Si47xx_IIC_RecvByte(NACK);
	Si47xx_IIC_Stop();
}

/*
************************************************************
*	ƣ	si47xx_readStatus
*
*	ܣ	ȡ״̬Ϣ
*
*	ڲ	
*
*	ز	status״ֵ̬
*
*	˵
************************************************************
*/
u8 si47xx_readStatus()
{
    u8 status;
   
    si47xx_ReadData(1,&status);

    return status;
}

/*
************************************************************
*	ƣ	si47xx_waitForCTS
*
*	ܣ	ȴCTSһ
*
*	ڲ	
*
*	ز	0:waitForCTSʧ  1waitForCTSɹ
*
*	˵
************************************************************
*/
uint8_t si47xx_waitForCTS()
{
    u16 i=1000;
    
    while (--i && !(si47xx_readStatus() & CTS))    // ֱCTSλ.
    {
        Delay();
    }
    if(i==0)
	{
		return 0;
	}
	
	return 1;
    /*ѡԷ0Ĵ*/
}


/*
************************************************************
*	ƣ	si47xx_command
*
*	ܣ	ȡֵ
*
*	ڲ	cmd_sizeֽ  cmd  reply_sizeֽ  replyصֵ
*
*	ز	
*
*	˵
************************************************************
*/
uint8_t si47xx_command(u8 cmd_size, u8 *cmd, u8 reply_size, u8 *reply)
{
    u16 timeout=1000;
	
    si47xx_WriteReg(cmd, cmd_size);     		//дĴ

    while(--timeout&&!si47xx_waitForCTS()) 		// ȴCTSһ
	{
		Delay();
	}	
	
	if(timeout==0)
	{
		return 0;
	}
    
    if(reply_size)								// ֵ.
    {
        si47xx_ReadData(reply_size, reply);
    }
	
	return 1;
}

/*
************************************************************
*	ƣ	fmTuneFreq
*
*	ܣ	FM_TUNE_FREQƵʲȡֵ
*
*	ڲ	frequencyƵ
*
*	ز	0:ɹ  1ʧ
*
*	˵FM_TUNE_FREQ=0x20
************************************************************
*/
static uint8_t fmTuneFreq(float frequency)
{
	u16 freq=0;
	u16 timeout=1000;
	
	freq = (u16)(frequency*100.0);
    cmd[0] = FM_TUNE_FREQ;
    cmd[1] = 0;
    cmd[2] = (u8)(freq >> 8);
	cmd[3] = (u8)(freq & 0x00FF);
    cmd[4] = (u8)0;  									//ANTCAPΪAuto
	
	while(--timeout&&!si47xx_command(5, cmd, 1, rsp)) 	// ȴCTSһ
	{
		Delay();
	}	
	
	if(timeout==0)
	{
		LOG_E("FM_TUNE_FREQʧ\r\n");
		return 0;
	}    
	
	return 1;
}

/*
************************************************************
*	ƣ	getIntStatus
*
*	ܣ	GET_INT_STATUSȡINT_STATUS
*
*	ڲ	
*
*	ز	rspصINT_STATUS״̬  
*
*	˵GET_INT_STATUS=0x14 
************************************************************
*/
u8 getIntStatus(void)
{
	u16 timeout=1000;
    u8 cmd[1] = {0};
    u8 rsp[1] = {0};

    cmd[0] = GET_INT_STATUS;

    while(--timeout&&!si47xx_command(1, cmd, 1, rsp)) 		
	{
		Delay();
	}	
	
	if(timeout==0)
	{
		LOG_E("GET_INT_STATUSʧ\r\n");
		return 0;
	}    
	
	return rsp[0];
}
/*
************************************************************
*	ƣ	fmAgcStatus
*
*	ܣ	FM_AGC_STATUSAGC״̬. 
*
*	ڲ	
*
*	ز	0ʧ  1ɹ
*
*	˵FM_AGC_STATUS=0x27

*    Outputs:
* 			 rf_agc_status:    RF AGC Ƿʹ
*									0 = RF AGCʹ
*									1 = RF AGCʧ
* 			 lna_gain_index:   LNA GAIN ֵ
*									0 = С˥ ()
*									1 C 25  ˥ֵ
*									26 = ˥ (С)
************************************************************
*/
uint8_t fmAgcStatus()
{
	u8 ucCmdBuf[2];
	u16 uiTimeOut;
	u8 i;

	ucCmdBuf[0] = FM_AGC_STATUS;
	si47xx_SendCmd(ucCmdBuf, 1);

	uiTimeOut = si47xx_WaitStatus80(100, 0);
	if (uiTimeOut == 0)
	{
		LOG_E("FM_AGC_STATUSʧ\r\n");
		return 0;
	}

	for (i = 0; i < 2; i++)
	{
		Si47xx_IIC_Ack();
		rsp[i] = Si47xx_I2C_RecvByte();
	}
	Si47xx_IIC_NAck();
	Si47xx_IIC_Stop();
	
    rf_agc_status = !!(rsp[0] & FM_AGC_STATUS_READ_RFAGCDIS);
    lna_gain_index   = rsp[0] & FM_AGC_STATUS_READ_LNA_GAIN_INDEX;
//	LOG_I("---------------FM_AGC_STATUS---------------\r\n");
//	LOG_I("rf_agc_status: = %d\r\n", rf_agc_status);
//	LOG_I("lna_gain_index: = %d\r\n", lna_gain_index);
//	LOG_I("-------------------------------------------\r\n");
	return 1;
}

/*
************************************************************
*	ƣ	fmAgc_Override
*
*	ܣ	AGC_OVERRIDEAGC״̬. 
*
*	ڲ	rfagcdis:   lna_gain_index
*
*	ز	0ʧ  1ɹ
*
*	˵AGC_OVERRIDE=0x28
*    ڲrfagcdisRF AGCǷʹ
*									0 = RF AGCʹ
*									1 = RF AGCʧ
*             lna_gain_index:LNA GAINֵ
*									0 = С˥ ()
*									1 C 25  ˥ֵ
*									26 = ˥ (С)
*    Outputs:
* 			 rf_agc_status:    RF AGC Ƿʹ
*									0 = RF AGCʹ
*									1 = RF AGCʧ
* 			 lna_gain_index:   LNA GAIN ֵ
*									0 = С˥ ()
*									1 C 25  ˥ֵ
*									26 = ˥ (С)
************************************************************
*/
uint8_t fmAgcOverride(u8 rfagcdis, u8 lna_gain_index)
{
	u8 ucCmdBuf[5];
	u16 uiTimeOut;

	ucCmdBuf[0] = FM_AGC_OVERRIDE;
	ucCmdBuf[1]=0;
	ucCmdBuf[1] = ucCmdBuf[1]|rfagcdis;
	ucCmdBuf[2] = 0;
	ucCmdBuf[2] = ucCmdBuf[2]|lna_gain_index;
	si47xx_SendCmd(ucCmdBuf, 3);

	uiTimeOut = si47xx_WaitStatus80(100, 0);
	if (uiTimeOut == 0)
	{
		LOG_E("FM_AGC_OVERRIDEʧ\r\n");
		return 0;
	}
	
	return 1;
}
/*
************************************************************
*	ƣ	fmTuneStatus
*
*	ܣ	FM_TUNE_STATUSFM_TUNE_FREQ or FM_SEEK_START״̬. 
*
*	ڲ	cancelCancel seek  intackSeek/Tune Interrupt Clear
*
*	ز	0ʧ  1ɹ
*
*	˵FM_TUNE_STATUS=0x22
      ڲcancelIf set, aborts a seek currently in progress.
			  intackIf set, clears the seek/tune complete interrupt status indicator
*    Outputs:These are global variables and are set by this method
* 			 fm_tune_status.stc:    The seek/tune is complete
* 			 fm_tune_status.bltf:   The seek reached the band limit or original start frequency
*  			 fm_tune_status.afcrl:  The AFC is railed if this is non-zero
* 			 fm_tune_status.valid:  The station is valid if this is non-zero
*  			 fm_tune_status.freq:   The current frequency
* 			 fm_tune_status.rssi:   The RSSI level read at tune.
*			 fm_tune_status.asnr:   The audio SNR level read at tune.
*  			 fm_tune_status.antcap: The current level of the tuning capacitor.
************************************************************
*/
uint8_t fmTuneStatus(u8 cancel, u8 intack)
{
	u8 ucCmdBuf[32];
	u16 uiTimeOut;
	u8 i;

	ucCmdBuf[0] = FM_TUNE_STATUS;
	ucCmdBuf[1] =0;
	ucCmdBuf[1] = ucCmdBuf[1]|(cancel<<1)|intack;
	si47xx_SendCmd(ucCmdBuf, 2);

	uiTimeOut = si47xx_WaitStatus80(100, 0);
	if (uiTimeOut == 0)
	{
		LOG_E("FM_TUNE_STATUSʧ\r\n");
		return 0;
	}

	for (i = 0; i < 7; i++)
	{
		Si47xx_IIC_Ack();
		rsp[i] = Si47xx_I2C_RecvByte();
	}
	Si47xx_IIC_NAck();
	Si47xx_IIC_Stop();
	
	// Parse the results
    fm_tune_status.stc    = !!(rsp[0] & STCINT);
    fm_tune_status.bltf   = !!(rsp[0] & FM_TUNE_STATUS_OUT_BLTF);
    fm_tune_status.afcrl  = !!(rsp[0] & FM_TUNE_STATUS_OUT_AFCRL);
    fm_tune_status.valid  = !!(rsp[0] & FM_TUNE_STATUS_OUT_VALID);
    fm_tune_status.freq   = ((float)(((u16)rsp[1] << 8) | (u16)rsp[2]))/100.0;
	fm_tune_status.freq=( (float)( (int)( (fm_tune_status.freq+0.05)*10 ) ) )/10;//ȡСһλЧ֣
    fm_tune_status.rssi   = rsp[3];
    fm_tune_status.asnr   = rsp[4];
    fm_tune_status.antcap = rsp[6];   
//	LOG_I("---------------FM_TUNE_STATUS---------------\r\n");
//	LOG_I("fm_tune_status.stc: = %d\r\n", fm_tune_status.stc);
//	LOG_I("fm_tune_status.bltf: = %d\r\n", fm_tune_status.bltf);
//	LOG_I("fm_tune_status.afcrl: = %d\r\n", fm_tune_status.afcrl);
//	LOG_I("fm_tune_status.valid: = %d\r\n", fm_tune_status.valid);
//	LOG_I("fm_tune_status.freq: = %f\r\n", fm_tune_status.freq);
//	LOG_I("fm_tune_status.rssi: = %d\r\n", fm_tune_status.rssi);
//	LOG_I("fm_tune_status.asnr: = %d\r\n", fm_tune_status.asnr);
//	LOG_I("fm_tune_status.antcap: = %d\r\n", fm_tune_status.antcap);
//	LOG_I("-------------------------------------------\r\n");
	return 1;
}
/*
************************************************************
*	ƣ	LogFmTuneStatus
*
*	ܣ	LogFmTuneStatus 
*
*	ڲ	
*
*	ز	
*
*	˵
************************************************************
*/
void LogFmTuneStatus()
{
	LOG_I("---------------FM_TUNE_STATUS---------------\r\n");
//	LOG_I("fm_tune_status.stc: = %d\r\n", fm_tune_status.stc);
//	LOG_I("fm_tune_status.bltf: = %d\r\n", fm_tune_status.bltf);
//	LOG_I("fm_tune_status.afcrl: = %d\r\n", fm_tune_status.afcrl);
//	LOG_I("fm_tune_status.valid: = %d\r\n", fm_tune_status.valid);
	LOG_I("fm_tune_status.freq: = %f\r\n", fm_tune_status.freq);
	LOG_I("fm_tune_status.rssi: = %d\r\n", fm_tune_status.rssi);
	LOG_I("fm_tune_status.asnr: = %d\r\n", fm_tune_status.asnr);
//	LOG_I("fm_tune_status.antcap: = %d\r\n", fm_tune_status.antcap);
	LOG_I("-------------------------------------------\r\n");
}







/*
************************************************************
*	ƣ	fmRsqStatus
*
*	ܣ	FM_RSQ_STATUSźǿȵϢ. 
*
*	ڲ   intackInterrupt Acknowledge.
*
*	ز	0ʧ  1ɹ
*
*	˵FM_RSQ_STATUS=0x23
*      ڲ intackIf set,Clears RSQINT, BLENDINT, SNRHINT, SNRLINT,
*      RSSIHINT, RSSILINT,MULTHINT, MULTLINT.
*    Outputs:These are global variables and are set by this method
* 			 fm_rsq_status.blend_int:  Blend Detect Interrupt  
*                           0 = Blend is within the Blend threshold settings.
*                           1 = Blend goes above or below the Blend threshold settings. 
* 			 fm_rsq_status.snrh_int:   SNR Detect High
*							0 = Received SNR has not exceeded above SNR high threshold.
*							1 = Received SNR has exceeded above SNR high threshold.
*  			 fm_rsq_status.snrl_int:   SNR Detect Low.
*							0 = Received SNR has not fallen below SNR low threshold.
*							1 = Received SNR has fallen below SNR low threshold.
* 			 fm_rsq_status.rssih_int:  RSSI Detect High.
*							0 = RSSI has not exceeded above RSSI high threshold.
*							1 = RSSI has exceeded above RSSI high threshold
*			 fm_rsq_status.rssil_int:  RSSI Detect Low.
*							0 = RSSI has not fallen below RSSI low threshold.
*							1 = RSSI has fallen below RSSI low threshold.
*  			 fm_rsq_status.smute:     Soft Mute Indicator.Indicates soft mute is engaged.
*			 AFCRL:     AFC Rail Indicator.Set if the AFC rails.
*			 VALID:     Valid Channel.
*							Set if the channel is currently valid and would have been found during a Seek
*			 PILOT:     Pilot Indicator. Indicates stereo pilot presence
*			 STBLEND:   Stereo Blend Indicator.
*							Indicates amount of stereo blend in% (100 = full stereo, 0 = full mono).
* 			 RSSI:      Pilot Indicator. Indicates stereo pilot presence
* 			 ASNR:      SNR.Contains the current SNR metric (0C127 dB).
* 			 MULT:      Multipath (Si4706/40/41/49 Only)
* 			 FREQOFF:   Frequency Offset.Signed frequency offset (kHz)
************************************************************
*/
uint8_t fmRsqStatus(u8 intack)
{
	u8 ucCmdBuf[32];
	u16 uiTimeOut;
	u8 i;

	ucCmdBuf[0] = FM_RSQ_STATUS;
	ucCmdBuf[1] =0;								
	ucCmdBuf[1] = ucCmdBuf[1]|intack;
	si47xx_SendCmd(ucCmdBuf, 2);

	uiTimeOut = si47xx_WaitStatus80(100, 0);
	if (uiTimeOut == 0)
	{
		LOG_E("FM_RSQ_STATUSʧ\r\n");
		return 0;
	}

	for (i = 0; i < 7; i++)
	{
		Si47xx_IIC_Ack();
		rsp[i] = Si47xx_I2C_RecvByte();
	}
	Si47xx_IIC_NAck();
	Si47xx_IIC_Stop();
	
	// Parse the results
    fm_rsq_status.blend_int    = !!(rsp[0] & FM_RSQ_STATUS_OUT_BLENDINT);
    fm_rsq_status.snrh_int   = !!(rsp[0] & FM_RSQ_STATUS_OUT_ASNRHINT);
    fm_rsq_status.snrl_int  = !!(rsp[0] & FM_RSQ_STATUS_OUT_ASNRLINT);
    fm_rsq_status.rssih_int  = !!(rsp[0] & FM_RSQ_STATUS_OUT_RSSIHINT);
	fm_rsq_status.rssil_int  = !!(rsp[0] & FM_RSQ_STATUS_OUT_RSSILINT);
	fm_rsq_status.smute  = !!(rsp[1] & FM_RSQ_STATUS_OUT_SMUTE);
    fm_rsq_status.afcrl  = !!(rsp[1] & FM_RSQ_STATUS_OUT_AFCRL);
	fm_rsq_status.valid  = !!(rsp[1] & FM_RSQ_STATUS_OUT_VALID);
	fm_rsq_status.pilot  = !!(rsp[2] & FM_RSQ_STATUS_OUT_PILOT);
	fm_rsq_status.stblend  = rsp[2] & FM_RSQ_STATUS_OUT_STBLEND;
    fm_rsq_status.rssi   = rsp[3];
    fm_rsq_status.asnr   = rsp[4];
    fm_rsq_status.freq_off = rsp[6];  
//	LOG_I("---------------FM_RSQ_STATUS---------------\r\n");
//	LOG_I("FM_RSQ_STATUS\r\n");
//	LOG_I("fm_rsq_status.blend_int: = %d\r\n", fm_rsq_status.blend_int);	
//	LOG_I("fm_rsq_status.snrh_int: = %d\r\n", fm_rsq_status.snrh_int);
//	LOG_I("fm_rsq_status.snrl_int: = %d\r\n", fm_rsq_status.snrl_int);
//	LOG_I("fm_rsq_status.rssih_int: = %d\r\n", fm_rsq_status.rssih_int);
//	LOG_I("fm_rsq_status.rssil_int: = %d\r\n", fm_rsq_status.rssil_int);
//	LOG_I("fm_rsq_status.smute: = %d\r\n", fm_rsq_status.smute);
//	LOG_I("fm_rsq_status.afcrl: = %d\r\n", fm_rsq_status.afcrl);
//	LOG_I("fm_rsq_status.valid: = %d\r\n", fm_rsq_status.valid);
//	LOG_I("fm_rsq_status.pilot: = %d\r\n", fm_rsq_status.pilot);
//	LOG_I("fm_rsq_status.stblend: = %d\r\n", fm_rsq_status.stblend);
//	LOG_I("fm_rsq_status.rssi: = %d\r\n", fm_rsq_status.rssi);
//	LOG_I("fm_rsq_status.freq_off: = %d\r\n", fm_rsq_status.freq_off);
//	LOG_I("-------------------------------------------\r\n");
	
	return 1;
}

/*
************************************************************
*	ƣ	si47xxFMRX_tune
*
*	ܣ	֪ĽƵν̨ܵϢ. 
*
*	ڲ	frequency Ƶ64-108MHz 10kHZΪ
*
*	ز	rssi
*
*	˵
************************************************************
*/
u8 si47xxFMRX_tune(float frequency)
{
	u16 timeout=1000;
	SeekTuneInProc = 1;               				// Enable the bit used for the interrupt of STC.
 	WaitSTCInterrupt = 1;             				// Call the tune command to start the tune.
	
	while(--timeout&&!fmTuneFreq(frequency))		//ִָ  STCINTλ
	{
		Delay();
	}	
	if(timeout==0)
	{
		LOG_E("FM_TUNE_FREQʧ\r\n");
		return 0;
	}    
    /*ڼ֮ǰȴжϣϣʹжϣϣѯò֣ע͸*/
	//while (WaitSTCInterrupt); 					//ȴж

    while (!(getIntStatus() & STCINT));   			//tune seekָҪȡSTCINT

	timeout=1000;
	//while(--timeout&&!fmTuneStatus(0, 1))  			//ȡ״̬0STCINT λ
	while(--timeout&&!fmTuneStatus(1, 0))  			//ȡ״̬0STCINT λ
	{
		Delay();
	}	
	if(timeout==0)
	{
		LOG_E("FM_TUNE_FREQʧ\r\n");
		return 0;
	}    
	
	SeekTuneInProc = 0;      

    return fm_tune_status.rssi;					  // RSSI 
}

/*
************************************************************
*	ƣ	insert_preset
*
*	ܣ	ĵ̨Ϣ
*
*	ڲ	frequencyƵ rssiƵʵrssi  seek_preset_rssi:ƵʵrssiĽṹԱ
*
*	ز	
*
*	˵
************************************************************
*/
static void insert_preset(float frequency, u8 rssi, u8 *seek_preset_rssi)
{
    u8 i;
    u8 min_rssi = 0xff;
    u8 min_rssi_preset = 0;

    /*һҵСrssiλ*/ 
    for ( i = 0; i < NUM_SEEK_PRESETS; i++ )
    {
        if(seek_preset_rssi[i] < min_rssi)
        {
            min_rssi = seek_preset_rssi[i];
            min_rssi_preset = i;
        }
    }

    /*ǰrssiССrssi*/ 
    if(rssi < min_rssi)
        return;

    for ( i = min_rssi_preset; i < NUM_SEEK_PRESETS - 1; i++ )
    {
        fm_freq.seek_preset_freq[i] = fm_freq.seek_preset_freq[i + 1];
        seek_preset_rssi[i] = seek_preset_rssi[i + 1];
    }
    fm_freq.seek_preset_freq[i] = 0;
    seek_preset_rssi[i] = 0;

    /*һΪ0λ*/
    for ( i = min_rssi_preset; i < NUM_SEEK_PRESETS; i++ )
    {
        if(fm_freq.seek_preset_freq[i] == 0)
        {
            fm_freq.seek_preset_freq[i] = frequency;
            seek_preset_rssi[i] = rssi;
            break;
        }
    }
}

/*
************************************************************
*	ƣ	si47xxFMRX_get_rssi
*
*	ܣ	ȡrssi
*
*	ڲ	
*
*	ز	rssi
*
*	˵
************************************************************
*/
u8 si47xxFMRX_get_rssi()
{
	u16 timeout=1000;
	
	while(--timeout&&!fmTuneStatus(0,0)) 		
	{
		Delay();
	}	
	
	if(timeout==0)
	{
		LOG_E("get_rssiʧ\r\n");
		return 0;
	}    

    return fm_tune_status.rssi;
}

/*
************************************************************
*	ƣ	si47xxFMRX_get_frequency
*
*	ܣ	ȡfrequency
*
*	ڲ	
*
*	ز	frequency
*
*	˵
************************************************************
*/
float si47xxFMRX_get_frequency()
{
	u16 timeout=1000;
	
	while(--timeout&&!fmTuneStatus(0,0)) 		
	{
		Delay();
	}	
	
	if(timeout==0)
	{
		LOG_E("get_frequencyʧ\r\n");
		return 0;
	}    
	
    return fm_tune_status.freq;
}

/*
************************************************************
*	ƣ	fmSeekStart
*
*	ܣ	fmSeekStartʼƵ
*
*	ڲ	seekUp  wrapѭ
*
*	ز	0:ʧ   1ɹ
*
*	˵FM_SEEK_START=0x21
************************************************************
*/
static uint8_t fmSeekStart(u8 seekUp, u8 wrap)
{
	u16 timeout=1000;
    cmd[0] = FM_SEEK_START;

	cmd[1] = 0;
    if(seekUp) cmd[1] |= FM_SEEK_START_IN_SEEKUP;    //Ƶ
	if(wrap)   cmd[1] |= FM_SEEK_START_IN_WRAP;      //ѭ

	while(--timeout&&!si47xx_command(2, cmd, 1, rsp)) 	
	{
		Delay();
	}	
	
	if(timeout==0)
	{
		LOG_E("FM_SEEK_STARTʧ\r\n");
		return 0;
	}    
	
	return 1;
}

/*
************************************************************
*	ƣ	si47xxFMRX_seek
*
*	ܣ	̨
*
*	ڲ	seekUp  seekmodeѭ
*
*	ز	1:ʧ   0ɹ   //
*
*	˵
************************************************************
*/
u8 si47xxFMRX_seek(u8 seekup, u8 seekmode)
{
	u16 timeout=1000;
	SeekTuneInProc = 1;				

 	WaitSTCInterrupt = 1;			
    fmSeekStart(seekup, !seekmode);

	
	
	while(--timeout&&!fmSeekStart(seekup, !seekmode)) 	
	{
		Delay();
	}	
	
	if(timeout==0)
	{
		LOG_E("FMRX_seekʧ\r\n");
		autoseek_flag=1;
		return 1;
	}   
	
    /*ڼ֮ǰȴжϣϣʹжϣϣѯò֣ע͸*/
	// while (WaitSTCInterrupt); 

    /* ȴstcλλҪseekչڴѭеfmtunestatus
	ԻõǰƵ,ڴ˵fmtunestatusʱȷIntackΪ.*/
	
    while (!(getIntStatus() & STCINT));

	timeout=1000;
	while(--timeout&&!fmTuneStatus(0, 1)) 	
	{
		Delay();
	}	
	
	if(timeout==0)
	{
		LOG_E("FMRX_seekʧ\r\n");
		autoseek_flag=1;
		return 1;
	}    

	SeekTuneInProc = 0;				

    return fm_tune_status.bltf; 
}
        

/*
************************************************************
*	ƣ	si47xxFMRX_autoseek
*
*	ܣ	ԶɨƵϢ
*
*	ڲ	
*
*	ز	0 ɨд   1 ɨɹ
*
*	˵ɨ貨βʹòǿźseek_presets顣 
*	δԤΣԤΪ㡣 ҪԤΪ㡣
*	ע⣬autoseekڼ䣬ԽֵԤĻᡣ 
*	ϵ͵ֵʱ䲢վյԤʱ϶ǽΪ㡣 
*	ӦøıԤеĽ
************************************************************
*/
uint8_t si47xxFMRX_autoseek(void)
{
    u8 i;
    u8 seek_fail;
    u8 num_found = 0;

    for ( i = 0; i < NUM_SEEK_PRESETS; i++ ) 
	{
        fm_freq.seek_preset_rssi[i] = 0;
        fm_freq.seek_preset_freq[i] = 0;
    }
	
	// si47xxFMRX_mute(1);// Mute the audio
	
    si47xxFMRX_tune(76);								//ô76MHzʼɨ
	si47xx_GetRadioStatus();
	printf("ɨʼ\r\n");
	LogFmTuneStatus();//ӡǰ״̬Ϣ
    seek_fail = si47xxFMRX_seek(1, 1);  				//seek up, stop at limits
	
	if(autoseek_flag==1)
	{
		LOG_E("FMRX_autoseekʧ\r\n");
	}
	LOG_I("---------------ɨ赽ĵ̨Ϣ---------------\r\n");
    while((seek_fail == 0)) 
	{
		insert_preset(fm_tune_status.freq, fm_tune_status.rssi, fm_freq.seek_preset_rssi);
		//LOG_I("FM̨:%2d\tƵ: %3.3f\tRSSI: %d\r\n",num_found + 1,fm_freq.seek_preset_freq[num_found],fm_freq.seek_preset_rssi[num_found]);
		LOG_I("FM̨:%2d\r\n",num_found + 1);
			
		LogFmTuneStatus();//ӡǰ״̬Ϣ
		
		seek_fail = si47xxFMRX_seek(1, 1); 			// seek up, stop at limts
		if(autoseek_flag==1)
		{
			LOG_E("FMRX_autoseekδɳ\r\n");
		}
		num_found++;
		
		
//		DelayXsec(5);//5msɨһ
		
    }

    //si47xxFMRX_tune(fm_freq.seek_preset_freq[0]);
	//si47xxFMRX_mute(0);								// Unmute
    fm_freq.seek_fm_num = (num_found > NUM_SEEK_PRESETS) ? NUM_SEEK_PRESETS : num_found;
	LOG_I("ɨ̨ܵ: %d\r\n", fm_freq.seek_fm_num);
	
	if(autoseek_flag==1)
	{
		LOG_E("ɨдɨ費\r\n");
		autoseek_flag=0;
		return 0;
	}
	return 1;
}

/*
************************************************************
*	ƣ	si47xx_PowerUp
*
*	ܣ	ϵ
*
*	ڲ	
*
*	ز	0ϵʧ  1ϵɹ
*
*	˵POWER_UP=0x01 CTS interrupt enabled/GPO2 output enabled/
*         Boot normally/Use crystal oscillator/Set to Analog Audio Output
************************************************************
*/
uint8_t si47xx_PowerUp(void)
{
	u8 ucCmdBuf[3];
	u16 uiTimeOut;
	ucCmdBuf[0] = POWER_UP;       				//POWER_UP
	ucCmdBuf[1] = 0xD0;          				//Set to FM Receive:Enable interrupts:CTS interrupt enabled/
												//GPO2 output enabled/Boot normally/Use crystal oscillator
	ucCmdBuf[2] = POWER_UP_IN_OPMODE_RX_ANALOG;	//Set to Analog Audio Output
	si47xx_WriteReg(ucCmdBuf, 3);
	uiTimeOut = si47xx_WaitStatus80(1000, 1);
	if (uiTimeOut == 0)
	{
		return 0;
	}
	
	return 1;
}

/*
************************************************************
*	ƣ	si47xx_PowerDown
*
*	ܣ	ȴӦϢ
*
*	ڲ	
*
*	ز	0ϵʧ  1ϵɹ
*
*	˵ POWER_DOWN=0x11
************************************************************
*/
uint8_t si47xx_PowerDown(void)
{
	u8 ucCmdBuf[1];
	u16 uiTimeOut;
	ucCmdBuf[0] = POWER_DOWN;					//POWER_DOWN
	si47xx_WriteReg(ucCmdBuf, 1);
	uiTimeOut = si47xx_WaitStatus80(1000, 1);
	if (uiTimeOut == 0)
	{
		return 0;
	}
	
	return 1;
}

/*
************************************************************
*	ƣ	si47xx_Reset
*
*	ܣ	ģ鸴λŸλ
*
*	ڲ	
*
*	ز	
*
*	˵
************************************************************
*/
void si47xx_Reset(void)
{
	si47xx_RESET_L;			
	Delay();
	si47xx_RESET_H;
}


/*
************************************************************
*	ƣ	si47xx_Init
*
*	ܣ	ʼFMģ
*
*	ڲ	
*
*	ز	
*
*	˵ ģ鸴λ λ ϵ ȡ汾Ϣѡ á
************************************************************
*/
void si47xx_Init(void)
{	
	u16 uiTimeOut=1000;
	u8 buf[8];
	
	/*IIC1ųʼ*/
	Si47xx_IIC_Init();
	
	/*si47xxRESET*/
	si47xx_RESETGPIO_Config();			
	
	/*оƬsi47xxλ*/
	si47xx_Reset();      
	printf("si47xxλ\r\n");	
	
	/*SI47xxϵ*/
	while(--uiTimeOut&&!si47xx_PowerUp())			
	{
		Delay();
	}
	if(uiTimeOut==0)	
	{
		LOG_E("si47xxϵʧ\r\n");
		return;
	}
	power_up=1;
	printf("si47xxϵ\r\n");
	
	/*ȡ汾Ϣ*/
	uiTimeOut=1000;
	while(--uiTimeOut&&!si47xx_GetRevision(buf)) 	
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		LOG_E("si47xxGetRevisionʧ\r\n");
	}
	else    				
	{
		LOG_I("---------------FMģ汾Ϣ---------------\r\n");
		LOG_I("\tPart Number = %d\r\n\tFirmware Revision = %c%c\r\n\tPatch ID = 0x%02X%02X\r\n\
		\tComponent Revision = 0x%c%c\r\n\tChip Revision = %c\r\n",buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);		
	}
	
//	/*˴ĬģʽҲSet GPO_IEN(property 0x0001)ʹRSQ InterruptRDS InterruptSTC Interruptж*/
//	
//	/*гƵʵȵֵʱƵս*/
//	si47xx_SoftMuteSet(64,0x0010,0x0004);										//ΪĬֵ(Զ)
//	
//	//si47xx_MonitorRSQSet(жԴжֵ);										// üźϢRSQ
	
	/*Ϊ(Ϊ0-63)*/
	uiTimeOut=1000;
	while(--uiTimeOut&&!si47xx_SetProperty(RX_VOLUME, RX_VOLUME_VOL_MAX)) 		//Ϊ(Ϊ0-63)
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		LOG_E("Set RX_VOLUMEʧ\r\n");
	}
	
//	/*  Ĭ0x0000 0x00020x0001ֱ*/
//	uiTimeOut=1000;
//	while(--uiTimeOut&&!si47xx_SetProperty(RX_HARD_MUTE, 0x0001)) 				//
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set RX_HARD_MUTE ʧ\r\n");
//	}
	
	//while(!si47xx_SetProperty(FM_MAX_TUNE_ERROR, 0x001E));					//Ƶʴ  Ĭ0x001E  30kHz
	
	si47xxFMRX_tune(92.6);														//óʼƵ λMHz rssiֵ
	
	//si47xxFMRX_autoseek();
}

/*
************************************************************
*	ƣ	si47xx_WaitStatus80
*
*	ܣ	ȴӦϢ
*
*	ڲ	_uiTimeOutʱȴ  _ucStopEnֽڸ
*
*	ز	0ʱ  㣺سɹ
*
*	˵
************************************************************
*/
u16 si47xx_WaitStatus80(u32 _uiTimeOut, u8 _ucStopEn)
{
	u8 ack;
	u8 status;
	u16 i;

	/*ȴ״̬Ϊ80*/
	for (i = 0; i < _uiTimeOut; i++)
	{
		Si47xx_IIC_Start();
		ack = Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS+1);	// 

		if (ack == 1)
		{
			Si47xx_IIC_NAck();
			Si47xx_IIC_Stop();
			return 0;	          							//Ӧʧ
		}
		status = Si47xx_I2C_RecvByte();
		if ((status == 0x80) || (status == 0x81))			//0x81
		{
			break;
		}
	}
	if (i == _uiTimeOut) 
	{
		Si47xx_IIC_NAck();
		Si47xx_IIC_Stop();
		return 0;											//ʱʧ
	}

	/*ɹˣһ1ξͳɹ */
	if (i == 0)
	{
		i = 1;
	}

	if  (_ucStopEn == 1)
	{
		Si47xx_IIC_NAck();
		Si47xx_IIC_Stop();
	}
	return i;
}

/*
************************************************************
*	ƣ	si47xx_GetRevision
*
*	ܣ	ȡ汾Ϣ
*
*	ڲ	_ReadBuf洢صİ汾Ϣbuf
*
*	ز	0ȡʧ  1ȡɹ
*
*	˵	GET_REV=0x10  
************************************************************
*/
uint8_t si47xx_GetRevision(uint8_t *_ReadBuf)
{
	u8 ucCmdBuf[2];
	u16 uiTimeOut;
	u8 i;

	ucCmdBuf[0] = GET_REV;
	si47xx_SendCmd(ucCmdBuf, 1);

	uiTimeOut = si47xx_WaitStatus80(10, 0);
	
	if (uiTimeOut == 0)
	{
		return 0;
	}
	Si47xx_IIC_Ack();
	for (i = 0; i < 8; i++)
	{
		_ReadBuf[i] = Si47xx_IIC_RecvByte(ACK);
	}
	Si47xx_IIC_NAck();
	Si47xx_IIC_Stop();
	
	return 1;
}


/*
************************************************************
*	ƣ	si47xx_SetProperty
*
*	ܣ	ָ
*
*	ڲ	_usPropNumberָ  _usPropValueõֵ
*
*	ز	0ʧ  1óɹ
*
*	˵	SET_PROPERTY=0x12  
************************************************************
*/
uint8_t si47xx_SetProperty(uint16_t _usPropNumber, uint16_t _usPropValue)
{
	u8 ucCmdBuf[32];
	u16 uiTimeOut;

	ucCmdBuf[0] = SET_PROPERTY;
	ucCmdBuf[1] = 0x00;

	ucCmdBuf[2] = _usPropNumber >> 8;
	ucCmdBuf[3] = _usPropNumber;

	ucCmdBuf[4] = _usPropValue >> 8;
	ucCmdBuf[5] = _usPropValue;
	si47xx_SendCmd(ucCmdBuf, 6);

	uiTimeOut = si47xx_WaitStatus80(100000, 1);
	
	if (uiTimeOut == 0)
	{
		return 0;
	}

	return 1;
}
/*
************************************************************
*	ƣ	si47xx_GetProperty
*
*	ܣ	ȡָ״̬Ϣ
*
*	ڲ	_usPropNumberָ  _ReadBuf洢صֵbuf
*
*	ز	0ȡʧ  1ȡɹ
*
*	˵  GET_PROPERTY=0x13  3ֽڣһֽĬ0  23ֽΪЧֵ
************************************************************
*/
uint8_t si47xx_GetProperty(uint16_t _usPropNumber,uint8_t *_ReadBuf)
{
	u8 i=0;
	u8 ucCmdBuf[32];
	u16 uiTimeOut;

	ucCmdBuf[0] = GET_PROPERTY;
	ucCmdBuf[1] = 0x00;

	ucCmdBuf[2] = _usPropNumber >> 8;
	ucCmdBuf[3] = _usPropNumber;
	si47xx_SendCmd(ucCmdBuf, 4);
	uiTimeOut = si47xx_WaitStatus80(100000, 1);

	if (uiTimeOut == 0)
	{
		return 0;
	}
	Si47xx_IIC_Ack();
	for (i = 0; i < 3; i++)
	{
		_ReadBuf[i] = Si47xx_IIC_RecvByte(ACK);
	}
	Si47xx_IIC_NAck();
	Si47xx_IIC_Stop();
	
	return 1;
}

/*
************************************************************
*	ƣ	si47xx_SetFMFreq
*
*	ܣ	FMĲƵ
*
*	ڲ	_uiFreqõƵֵ
*
*	ز	0Ƶʧ  1Ƶʳɹ
*
*	˵	FM_TUNE_FREQ=0x20  ȡGET_INT_STATUS״̬
************************************************************
*/
uint8_t si47xx_SetFMFreq(float _uiFreq)
{
	u8 ucCmdBuf[16];
	u16 uiTimeOut;
	u16 i,j;
	u8 status;
	u16 freq=0;
	
    freq=(u16)(_uiFreq*100);
	ucCmdBuf[0] = FM_TUNE_FREQ;
	ucCmdBuf[1] = 0x00;
	ucCmdBuf[2] = freq >> 8;
	ucCmdBuf[3] = freq;
	ucCmdBuf[4] = 0x00;
	si47xx_SendCmd(ucCmdBuf, 5);

	uiTimeOut = si47xx_WaitStatus80(1000, 1);
	if (uiTimeOut == 0)
	{
		return 0;
	}

	for (i = 0; i < 5000; i++)
	{
		ucCmdBuf[0] = GET_INT_STATUS;
		si47xx_SendCmd(ucCmdBuf, 1);

		for(j=0;j<1000;j++)
		{
			;
		}
		Si47xx_IIC_Start();
		Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS+1);	// 
		Si47xx_IIC_WaitAck(10);
		status = Si47xx_I2C_RecvByte();
		Si47xx_IIC_Stop();
		if (status == 0x81)
		{
			break;
		}
	}

	if (i == 5000)
	{
		LOG_E("si47xx_SetFMFreq,error\r\n");
		return 0;
	}
	
	return 1;
}
/*
************************************************************
*	ƣ	si47xx_GetRadioStatus
*
*	ܣ	ȡFM_TUNE_STATUS״̬
*
*	ڲ	ޣֵfm_tune_status_stṹ壩
*
*	ز	0ȡ״̬ʧ  1ȡ״̬ɹ
*
*	˵	FM_TUNE_STATUS=0x22  
************************************************************
*/
uint8_t si47xx_GetRadioStatus(void)
{
	u16 uiTimeOut=1000;
	
	//while(--uiTimeOut&&!fmTuneStatus(0,1));
	while(--uiTimeOut&&!fmTuneStatus(0,0));
	if(uiTimeOut==0)
	{
		memset(&fm_tune_status,0,sizeof(fm_tune_status_st));
		LOG_E("ȡTUNE״̬ϢʧܣЧTUNEϢ\r\n");
		return 0;	
	}
	//LOG_D("ȡTUNE״̬ϢɹЧTUNEϢ\r\n");
	
	return 1;
}

/*
************************************************************
*	ƣ	si47xx_ScanUpdateFMFreq
*
*	ܣ	ɨƵʲƵ
*
*	ڲ	
*
*	ز	
*
*	˵	
************************************************************
*/
uint8_t si47xx_ScanUpdateFMFreq(void)
{
	return si47xxFMRX_autoseek();
}

/*
************************************************************
*	ƣ	si47xx_MonitorRSQSet
*
*	ܣ	üźϢRSQ
*
*	ڲ	rsq_int_source:rsqжԴ  rsq_int_source_valueжԴ
*
*	ز	0:üRSQʧ   1:üRSQɹ
*
*	˵	
************************************************************
*/
uint8_t si47xx_MonitorRSQSet(u16 rsq_int_source,u16 rsq_int_source_value)
{
	u16 uiTimeOut=1000;
	
	/*ʹRSQж,üźʹ*/
	while(--uiTimeOut&&!si47xx_SetProperty(GPO_IEN, GPO_IEN_RSQIEN)) 			//ʹRSQж,üźʹ
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		LOG_E("Set GPO_IEN_RSQIENʧ\r\n");
		return 0;
	}
	
	/*üź*/
	uiTimeOut=1000;
	while(--uiTimeOut&&!si47xx_SetProperty(FM_RSQ_INT_SOURCE, rsq_int_source)) 	//źָصж
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		LOG_E("Set FM_RSQ_INT_SOURCEʧ\r\n");
		return 0;
	}
	uiTimeOut=1000;
	while(--uiTimeOut&&!si47xx_SetProperty(rsq_int_source, rsq_int_source_value))//жԴ
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		LOG_E("Set FM_RSQ_INT_SOURCE_VALUEʧ\r\n");
		return 0;
	}
	
	return 1;
}

/*
************************************************************
*	ƣ	si47xx_MonitorRSQ
*
*	ܣ	ȡźżźϢRSQ
*
*	ڲ	
*
*	ز	0:ȡRSQʧ   1:ȡRSQɹ
*
*	˵	
************************************************************
*/
uint8_t si47xx_FMRsqStatusMoniter()
{
	u16 uiTimeOut=1000;
	
	uiTimeOut=1000;
	while(--uiTimeOut&&!fmRsqStatus(1))                     //ȡFM_RSQ_STATUSź
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		return 0;
	}
	
	return 1;
}


/*
************************************************************
*	ƣ	si47xx_SoftMuteSet
*
*	ܣ	
*
*	ڲ	value1FM_SOFT_MUTE_RATEֵ  
*               value2FM_SOFT_MUTE_MAX_ATTENUATIONֵ
*               value3FM_SOFT_MUTE_SNR_THRESHOLDֵ
*
*	ز	0:üRSQʧ   1:üRSQɹ
*
*	˵	
************************************************************
*/
uint8_t si47xx_SoftMuteSet(u16 value1,u16 value2,u16 value3)
{
	u16 uiTimeOut=1000;
	
	/*гƵʵȵֵʱƵս*/
	while(--uiTimeOut&&!si47xx_SetProperty(FM_SOFT_MUTE_RATE, value1)) 				// :1255 Ĭ64
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		LOG_E("Set FM_SOFT_MUTE_RATEʧ\r\n");
		return 0;
	}
	
	uiTimeOut=1000;
	while(--uiTimeOut&&!si47xx_SetProperty(FM_SOFT_MUTE_MAX_ATTENUATION, value2)) 	//˥: 0C31 Ĭ0x0010
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		LOG_E("Set FM_SOFT_MUTE_MAX_ATTENUATIONʧ\r\n");
		return 0;
	}
	uiTimeOut=1000;
	
	while(--uiTimeOut&&!si47xx_SetProperty(FM_SOFT_MUTE_SNR_THRESHOLD, value3)) 	//ýֵ : 0C15 Ĭ0x0004
	{
		Delay();
	}	
	if(uiTimeOut==0)
	{
		LOG_E("Set FM_SOFT_MUTE_SNR_THRESHOLDʧ\r\n");
		return 0;
	}
	
	return 1;
}






///*TUNE_STATUSر*/
//fm_tune_status_st fm_tune_status;

///*RSQ_STATUSر*/
//fm_rsq_status_st fm_rsq_status;

///*AGC_STATUSر*/
//u8 rf_agc_status;
//u8 lna_gain_index;

///*ƵϢ*/
//fm_freq_st fm_freq;

///*״̬ͻظbuf*/
//u8	power_up=0;					//ϵ״ָ̬ʾλ
//u8 	WaitSTCInterrupt = 0;
//u8 	SeekTuneInProc = 0;
//u8  cmd[8];                     //Ϣ洢buf
//u8  rsp[13];					//ظϢ洢buf
//u8  status;						//ָʾFMģǷ
//u8  autoseek_flag=0;    		//ɨƵ־

///*
//************************************************************
//*	ƣ	si47xx_RESETGPIO_Config
//*
//*	ܣ	λ
//*
//*	ڲ	
//*
//*	ز	
//*
//*	˵ PB0--RESET
//************************************************************
//*/
//void si47xx_RESETGPIO_Config(void)
//{		
//	GPIO_InitTypeDef GPIO_InitStructure;       			//һGPIO_InitTypeDef͵Ľṹ

//	RCC_APB2PeriphClockCmd( si47xx_RESET_CLK, ENABLE);	//LEDصGPIOʱ

//	GPIO_InitStructure.GPIO_Pin = si47xx_RESET_PIN;		//ѡҪƵGPIO
//	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 	//ģʽΪͨ 
//	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 	//Ϊ50MHz	

//	GPIO_Init(si47xx_RESET_PORT, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
//}

///*
//************************************************************
//*	ƣ	si47xx_SendCmd
//*
//*	ܣ	ģ鷢
//*
//*	ڲ	_pCmdBuf  _ucCmdLenֽ 
//*
//*	ز	0дʧ  1дɹ
//*
//*	˵
//************************************************************
//*/
//uint8_t si47xx_SendCmd(u8 *_pCmdBuf, u8 _ucCmdLen)
//{
//	u8 ack;
//	u8 i;

//	Si47xx_IIC_Start();
//	ack = Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS);
//	if (ack != 0)
//	{
//		goto err;
//	}
//	for (i = 0; i < _ucCmdLen; i++)
//	{
//		ack = Si47xx_IIC_SendByte(_pCmdBuf[i]);
//		if (ack != 0)
//		{
//			goto err;
//		}
//	}
//	Si47xx_IIC_Stop();
//	return 1;

//err:
//	Si47xx_IIC_Stop();
//	return 0;
//}

///*
//************************************************************
//*	ƣ	Delay
//*
//*	ܣ	ӳ
//*
//*	ڲ	 
//*
//*	ز	
//*
//*	˵
//************************************************************
//*/
//static void Delay(void)
//{
//	int i=0,j=0;
//	
//	for(i=0;i<1000;i++)
//	{
//		for(j=0;j<1000;j++)
//		{;}
//	}
//}

///*
//************************************************************
//*	ƣ	si47xx_WriteReg
//*
//*	ܣ	ģĴд
//*
//*	ڲ	_pCmdBuf  _ucCmdLenֽ 
//*
//*	ز	0дʧ  1дɹ
//*
//*	˵
//************************************************************
//*/
//uint8_t si47xx_WriteReg(u8 *_pCmdBuf, u8 _ucCmdLen)
//{
//	uint8_t ack;
//	uint8_t i;

//	Si47xx_IIC_Start();
//	ack = Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS);
//	if (ack != 0)
//	{
//		goto err;
//	}
//	for (i = 0; i < _ucCmdLen; i++)
//	{
//		ack = Si47xx_IIC_SendByte(_pCmdBuf[i]);
//		if (ack != 0)
//		{
//			goto err;
//		}
//	}
//	Si47xx_IIC_Stop();
//	return 1;

//err:
//	Si47xx_IIC_Stop();
//	return 0;
//}

///*
//************************************************************
//*	ƣ	si47xx_ReadData
//*
//*	ܣ	ȡֵ
//*
//*	ڲ	numֽ  Read洢buf
//*
//*	ز	
//*
//*	˵
//************************************************************
//*/
//void si47xx_ReadData(u8 num, u8 *Read)
//{
//	unsigned char i;

//	Si47xx_IIC_Start();
//	Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS+1);
//	for(i=0;i<(num-1);i++)
//	{
//		Read[i] = Si47xx_IIC_RecvByte(ACK);
//	}
//	*Read=Si47xx_IIC_RecvByte(NACK);
//	Si47xx_IIC_Stop();
//}

///*
//************************************************************
//*	ƣ	si47xx_readStatus
//*
//*	ܣ	ȡ״̬Ϣ
//*
//*	ڲ	
//*
//*	ز	status״ֵ̬
//*
//*	˵
//************************************************************
//*/
//u8 si47xx_readStatus()
//{
//    u8 status;
//   
//    si47xx_ReadData(1,&status);

//    return status;
//}

///*
//************************************************************
//*	ƣ	si47xx_waitForCTS
//*
//*	ܣ	ȴCTSһ
//*
//*	ڲ	
//*
//*	ز	0:waitForCTSʧ  1waitForCTSɹ
//*
//*	˵
//************************************************************
//*/
//uint8_t si47xx_waitForCTS()
//{
//    u16 i=1000;
//    
//    while (--i && !(si47xx_readStatus() & CTS))    // ֱCTSλ.
//    {
//        Delay();
//    }
//    if(i==0)
//	{
//		return 0;
//	}
//	
//	return 1;
//    /*ѡԷ0Ĵ*/
//}


///*
//************************************************************
//*	ƣ	si47xx_command
//*
//*	ܣ	ȡֵ
//*
//*	ڲ	cmd_sizeֽ  cmd  reply_sizeֽ  replyصֵ
//*
//*	ز	
//*
//*	˵
//************************************************************
//*/
//uint8_t si47xx_command(u8 cmd_size, u8 *cmd, u8 reply_size, u8 *reply)
//{
//    u16 timeout=1000;
//	
//    si47xx_WriteReg(cmd, cmd_size);     		//дĴ

//    while(--timeout&&!si47xx_waitForCTS()) 		// ȴCTSһ
//	{
//		Delay();
//	}	
//	
//	if(timeout==0)
//	{
//		return 0;
//	}
//    
//    if(reply_size)								// ֵ.
//    {
//        si47xx_ReadData(reply_size, reply);
//    }
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	fmTuneFreq
//*
//*	ܣ	FM_TUNE_FREQƵʲȡֵ
//*
//*	ڲ	frequencyƵ
//*
//*	ز	0:ɹ  1ʧ
//*
//*	˵FM_TUNE_FREQ=0x20
//************************************************************
//*/
//static uint8_t fmTuneFreq(float frequency)
//{
//	u16 freq=0;
//	u16 timeout=1000;
//	
//	freq = (u16)(frequency*100.0);
//    cmd[0] = FM_TUNE_FREQ;
//    cmd[1] = 0;
//    cmd[2] = (u8)(freq >> 8);
//	cmd[3] = (u8)(freq & 0x00FF);
//    cmd[4] = (u8)0;  									//ANTCAPΪAuto
//	
//	while(--timeout&&!si47xx_command(5, cmd, 1, rsp)) 	// ȴCTSһ
//	{
//		Delay();
//	}	
//	
//	if(timeout==0)
//	{
//		LOG_E("FM_TUNE_FREQʧ\r\n");
//		return 0;
//	}    
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	getIntStatus
//*
//*	ܣ	GET_INT_STATUSȡINT_STATUS
//*
//*	ڲ	
//*
//*	ز	rspصINT_STATUS״̬  
//*
//*	˵GET_INT_STATUS=0x14 
//************************************************************
//*/
//u8 getIntStatus(void)
//{
//	u16 timeout=1000;
//    u8 cmd[1] = {0};
//    u8 rsp[1] = {0};

//    cmd[0] = GET_INT_STATUS;

//    while(--timeout&&!si47xx_command(1, cmd, 1, rsp)) 		
//	{
//		Delay();
//	}	
//	
//	if(timeout==0)
//	{
//		LOG_E("GET_INT_STATUSʧ\r\n");
//		return 0;
//	}    
//	
//	return rsp[0];
//}
///*
//************************************************************
//*	ƣ	fmAgcStatus
//*
//*	ܣ	FM_AGC_STATUSAGC״̬. 
//*
//*	ڲ	
//*
//*	ز	0ʧ  1ɹ
//*
//*	˵FM_AGC_STATUS=0x27

//*    Outputs:
//* 			 rf_agc_status:    RF AGC Ƿʹ
//*									0 = RF AGCʹ
//*									1 = RF AGCʧ
//* 			 lna_gain_index:   LNA GAIN ֵ
//*									0 = С˥ ()
//*									1 C 25  ˥ֵ
//*									26 = ˥ (С)
//************************************************************
//*/
//uint8_t fmAgcStatus()
//{
//	u8 ucCmdBuf[2];
//	u16 uiTimeOut;
//	u8 i;

//	ucCmdBuf[0] = FM_AGC_STATUS;
//	si47xx_SendCmd(ucCmdBuf, 1);

//	uiTimeOut = si47xx_WaitStatus80(100, 0);
//	if (uiTimeOut == 0)
//	{
//		LOG_E("FM_AGC_STATUSʧ\r\n");
//		return 0;
//	}

//	for (i = 0; i < 2; i++)
//	{
//		Si47xx_IIC_Ack();
//		rsp[i] = Si47xx_I2C_RecvByte();
//	}
//	Si47xx_IIC_NAck();
//	Si47xx_IIC_Stop();
//	
//    rf_agc_status = !!(rsp[0] & FM_AGC_STATUS_READ_RFAGCDIS);
//    lna_gain_index   = rsp[0] & FM_AGC_STATUS_READ_LNA_GAIN_INDEX;
//	LOG_I("---------------FM_AGC_STATUS---------------\r\n");
//	LOG_I("rf_agc_status: = %d\r\n", rf_agc_status);
//	LOG_I("lna_gain_index: = %d\r\n", lna_gain_index);
//	LOG_I("-------------------------------------------\r\n");
//	return 1;
//}

///*
//************************************************************
//*	ƣ	fmAgc_Override
//*
//*	ܣ	AGC_OVERRIDEAGC״̬. 
//*
//*	ڲ	rfagcdis:   lna_gain_index
//*
//*	ز	0ʧ  1ɹ
//*
//*	˵AGC_OVERRIDE=0x28
//*    ڲrfagcdisRF AGCǷʹ
//*									0 = RF AGCʹ
//*									1 = RF AGCʧ
//*             lna_gain_index:LNA GAINֵ
//*									0 = С˥ ()
//*									1 C 25  ˥ֵ
//*									26 = ˥ (С)
//*    Outputs:
//* 			 rf_agc_status:    RF AGC Ƿʹ
//*									0 = RF AGCʹ
//*									1 = RF AGCʧ
//* 			 lna_gain_index:   LNA GAIN ֵ
//*									0 = С˥ ()
//*									1 C 25  ˥ֵ
//*									26 = ˥ (С)
//************************************************************
//*/
//uint8_t fmAgcOverride(u8 rfagcdis, u8 lna_gain_index)
//{
//	u8 ucCmdBuf[5];
//	u16 uiTimeOut;

//	ucCmdBuf[0] = FM_AGC_OVERRIDE;
//	ucCmdBuf[1]=0;
//	ucCmdBuf[1] = ucCmdBuf[1]|rfagcdis;
//	ucCmdBuf[2] = 0;
//	ucCmdBuf[2] = ucCmdBuf[2]|lna_gain_index;
//	si47xx_SendCmd(ucCmdBuf, 3);

//	uiTimeOut = si47xx_WaitStatus80(100, 0);
//	if (uiTimeOut == 0)
//	{
//		LOG_E("FM_AGC_OVERRIDEʧ\r\n");
//		return 0;
//	}
//	
//	return 1;
//}
///*
//************************************************************
//*	ƣ	fmTuneStatus
//*
//*	ܣ	FM_TUNE_STATUSFM_TUNE_FREQ or FM_SEEK_START״̬. 
//*
//*	ڲ	cancelCancel seek  intackSeek/Tune Interrupt Clear
//*
//*	ز	0ʧ  1ɹ
//*
//*	˵FM_TUNE_STATUS=0x22
//      ڲcancelIf set, aborts a seek currently in progress.
//			  intackIf set, clears the seek/tune complete interrupt status indicator
//*    Outputs:These are global variables and are set by this method
//* 			 fm_tune_status.stc:    The seek/tune is complete
//* 			 fm_tune_status.bltf:   The seek reached the band limit or original start frequency
//*  			 fm_tune_status.afcrl:  The AFC is railed if this is non-zero
//* 			 fm_tune_status.valid:  The station is valid if this is non-zero
//*  			 fm_tune_status.freq:   The current frequency
//* 			 fm_tune_status.rssi:   The RSSI level read at tune.
//*			 fm_tune_status.asnr:   The audio SNR level read at tune.
//*  			 fm_tune_status.antcap: The current level of the tuning capacitor.
//************************************************************
//*/
//uint8_t fmTuneStatus(u8 cancel, u8 intack)
//{
//	u8 ucCmdBuf[32];
//	u16 uiTimeOut;
//	u8 i;

//	ucCmdBuf[0] = FM_TUNE_STATUS;
//	ucCmdBuf[1] =0;
//	ucCmdBuf[1] = ucCmdBuf[1]|(cancel<<1)|intack;
//	si47xx_SendCmd(ucCmdBuf, 2);

//	uiTimeOut = si47xx_WaitStatus80(100, 0);
//	if (uiTimeOut == 0)
//	{
//		LOG_E("FM_TUNE_STATUSʧ\r\n");
//		return 0;
//	}

//	for (i = 0; i < 7; i++)
//	{
//		Si47xx_IIC_Ack();
//		rsp[i] = Si47xx_I2C_RecvByte();
//	}
//	Si47xx_IIC_NAck();
//	Si47xx_IIC_Stop();
//	
//	// Parse the results
//    fm_tune_status.stc    = !!(rsp[0] & STCINT);
//    fm_tune_status.bltf   = !!(rsp[0] & FM_TUNE_STATUS_OUT_BTLF);
//    fm_tune_status.afcrl  = !!(rsp[0] & FM_TUNE_STATUS_OUT_AFCRL);
//    fm_tune_status.valid  = !!(rsp[0] & FM_TUNE_STATUS_OUT_VALID);
//    fm_tune_status.freq   = ((float)(((u16)rsp[1] << 8) | (u16)rsp[2]))/100;
//    fm_tune_status.rssi   = rsp[3];
//    fm_tune_status.asnr   = rsp[4];
//    fm_tune_status.antcap = rsp[6];   
////	LOG_I("---------------FM_TUNE_STATUS---------------\r\n");
////	LOG_I("fm_tune_status.stc: = %d\r\n", fm_tune_status.stc);
////	LOG_I("fm_tune_status.bltf: = %d\r\n", fm_tune_status.bltf);
////	LOG_I("fm_tune_status.afcrl: = %d\r\n", fm_tune_status.afcrl);
////	LOG_I("fm_tune_status.valid: = %d\r\n", fm_tune_status.valid);
////	LOG_I("fm_tune_status.freq: = %f\r\n", fm_tune_status.freq);
////	LOG_I("fm_tune_status.rssi: = %d\r\n", fm_tune_status.rssi);
////	LOG_I("fm_tune_status.asnr: = %d\r\n", fm_tune_status.asnr);
////	LOG_I("fm_tune_status.antcap: = %d\r\n", fm_tune_status.antcap);
////	LOG_I("-------------------------------------------\r\n");
//	return 1;
//}
///*
//************************************************************
//*	ƣ	LogFmTuneStatus
//*
//*	ܣ	LogFmTuneStatus 
//*
//*	ڲ	
//*
//*	ز	
//*
//*	˵
//************************************************************
//*/
//void LogFmTuneStatus()
//{
//	LOG_I("---------------FM_TUNE_STATUS---------------\r\n");
//	LOG_I("fm_tune_status.stc:    = %d\r\n", fm_tune_status.stc);
//	LOG_I("fm_tune_status.bltf:   = %d\r\n", fm_tune_status.bltf);
//	LOG_I("fm_tune_status.afcrl:  = %d\r\n", fm_tune_status.afcrl);
//	LOG_I("fm_tune_status.valid:  = %d\r\n", fm_tune_status.valid);
//	LOG_I("fm_tune_status.freq:   = %f\r\n", fm_tune_status.freq);
//	LOG_I("fm_tune_status.rssi:   = %d\r\n", fm_tune_status.rssi);
//	LOG_I("fm_tune_status.asnr:   = %d\r\n", fm_tune_status.asnr);
//	LOG_I("fm_tune_status.antcap: = %d\r\n", fm_tune_status.antcap);
//	LOG_I("-------------------------------------------\r\n");
//}



///*
//************************************************************
//*	ƣ	fmRsqStatus
//*
//*	ܣ	FM_RSQ_STATUSźǿȵϢ. 
//*
//*	ڲ   intackInterrupt Acknowledge.
//*
//*	ز	0ʧ  1ɹ
//*
//*	˵FM_RSQ_STATUS=0x23
//*      ڲ intackIf set,Clears RSQINT, BLENDINT, SNRHINT, SNRLINT,
//*      RSSIHINT, RSSILINT,MULTHINT, MULTLINT.
//*    Outputs:These are global variables and are set by this method
//* 			 fm_rsq_status.blend_int:  Blend Detect Interrupt  
//*                           0 = Blend is within the Blend threshold settings.
//*                           1 = Blend goes above or below the Blend threshold settings. 
//* 			 fm_rsq_status.snrh_int:   SNR Detect High
//*							0 = Received SNR has not exceeded above SNR high threshold.
//*							1 = Received SNR has exceeded above SNR high threshold.
//*  			 fm_rsq_status.snrl_int:   SNR Detect Low.
//*							0 = Received SNR has not fallen below SNR low threshold.
//*							1 = Received SNR has fallen below SNR low threshold.
//* 			 fm_rsq_status.rssih_int:  RSSI Detect High.
//*							0 = RSSI has not exceeded above RSSI high threshold.
//*							1 = RSSI has exceeded above RSSI high threshold
//*			 fm_rsq_status.rssil_int:  RSSI Detect Low.
//*							0 = RSSI has not fallen below RSSI low threshold.
//*							1 = RSSI has fallen below RSSI low threshold.
//*  			 fm_rsq_status.smute:     Soft Mute Indicator.Indicates soft mute is engaged.
//*			 AFCRL:     AFC Rail Indicator.Set if the AFC rails.
//*			 VALID:     Valid Channel.
//*							Set if the channel is currently valid and would have been found during a Seek
//*			 PILOT:     Pilot Indicator. Indicates stereo pilot presence
//*			 STBLEND:   Stereo Blend Indicator.
//*							Indicates amount of stereo blend in% (100 = full stereo, 0 = full mono).
//* 			 RSSI:      Pilot Indicator. Indicates stereo pilot presence
//* 			 ASNR:      SNR.Contains the current SNR metric (0C127 dB).
//* 			 MULT:      Multipath (Si4706/40/41/49 Only)
//* 			 FREQOFF:   Frequency Offset.Signed frequency offset (kHz)
//************************************************************
//*/
//uint8_t fmRsqStatus(u8 intack)
//{
//	u8 ucCmdBuf[32];
//	u16 uiTimeOut;
//	u8 i;

//	ucCmdBuf[0] = FM_RSQ_STATUS;
//	ucCmdBuf[1] =0;								
//	ucCmdBuf[1] = ucCmdBuf[1]|intack;
//	si47xx_SendCmd(ucCmdBuf, 2);

//	uiTimeOut = si47xx_WaitStatus80(100, 0);
//	if (uiTimeOut == 0)
//	{
//		LOG_E("FM_RSQ_STATUSʧ\r\n");
//		return 0;
//	}

//	for (i = 0; i < 7; i++)
//	{
//		Si47xx_IIC_Ack();
//		rsp[i] = Si47xx_I2C_RecvByte();
//	}
//	Si47xx_IIC_NAck();
//	Si47xx_IIC_Stop();
//	
//	// Parse the results
//    fm_rsq_status.blend_int    = !!(rsp[0] & FM_RSQ_STATUS_OUT_BLENDINT);
//    fm_rsq_status.snrh_int   = !!(rsp[0] & FM_RSQ_STATUS_OUT_ASNRHINT);
//    fm_rsq_status.snrl_int  = !!(rsp[0] & FM_RSQ_STATUS_OUT_ASNRLINT);
//    fm_rsq_status.rssih_int  = !!(rsp[0] & FM_RSQ_STATUS_OUT_RSSIHINT);
//	fm_rsq_status.rssil_int  = !!(rsp[0] & FM_RSQ_STATUS_OUT_RSSILINT);
//	fm_rsq_status.smute  = !!(rsp[1] & FM_RSQ_STATUS_OUT_SMUTE);
//    fm_rsq_status.afcrl  = !!(rsp[1] & FM_RSQ_STATUS_OUT_AFCRL);
//	fm_rsq_status.valid  = !!(rsp[1] & FM_RSQ_STATUS_OUT_VALID);
//	fm_rsq_status.pilot  = !!(rsp[2] & FM_RSQ_STATUS_OUT_PILOT);
//	fm_rsq_status.stblend  = rsp[2] & FM_RSQ_STATUS_OUT_STBLEND;
//    fm_rsq_status.rssi   = rsp[3];
//    fm_rsq_status.asnr   = rsp[4];
//    fm_rsq_status.freq_off = rsp[6];  
////	LOG_I("---------------FM_RSQ_STATUS---------------\r\n");
////	LOG_I("FM_RSQ_STATUS\r\n");
////	LOG_I("fm_rsq_status.blend_int: = %d\r\n", fm_rsq_status.blend_int);	
////	LOG_I("fm_rsq_status.snrh_int: = %d\r\n", fm_rsq_status.snrh_int);
////	LOG_I("fm_rsq_status.snrl_int: = %d\r\n", fm_rsq_status.snrl_int);
////	LOG_I("fm_rsq_status.rssih_int: = %d\r\n", fm_rsq_status.rssih_int);
////	LOG_I("fm_rsq_status.rssil_int: = %d\r\n", fm_rsq_status.rssil_int);
////	LOG_I("fm_rsq_status.smute: = %d\r\n", fm_rsq_status.smute);
////	LOG_I("fm_rsq_status.afcrl: = %d\r\n", fm_rsq_status.afcrl);
////	LOG_I("fm_rsq_status.valid: = %d\r\n", fm_rsq_status.valid);
////	LOG_I("fm_rsq_status.pilot: = %d\r\n", fm_rsq_status.pilot);
////	LOG_I("fm_rsq_status.stblend: = %d\r\n", fm_rsq_status.stblend);
////	LOG_I("fm_rsq_status.rssi: = %d\r\n", fm_rsq_status.rssi);
////	LOG_I("fm_rsq_status.freq_off: = %d\r\n", fm_rsq_status.freq_off);
////	LOG_I("-------------------------------------------\r\n");
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	LogFmRsqStatus
//*
//*	ܣ	LogFmRsqStatus 
//*
//*	ڲ	
//*
//*	ز	
//*
//*	˵
//************************************************************
//*/
//void LogFmRsqStatus()
//{
//	LOG_I("---------------FM_RSQ_STATUS---------------\r\n");
//	LOG_I("FM_RSQ_STATUS\r\n");
//	LOG_I("fm_rsq_status.blend_int:= %d\r\n", fm_rsq_status.blend_int);	
//	LOG_I("fm_rsq_status.snrh_int: = %d\r\n", fm_rsq_status.snrh_int);
//	LOG_I("fm_rsq_status.snrl_int: = %d\r\n", fm_rsq_status.snrl_int);
//	LOG_I("fm_rsq_status.rssih_int:= %d\r\n", fm_rsq_status.rssih_int);
//	LOG_I("fm_rsq_status.rssil_int:= %d\r\n", fm_rsq_status.rssil_int);
//	LOG_I("fm_rsq_status.smute:    = %d\r\n", fm_rsq_status.smute);
//	LOG_I("fm_rsq_status.afcrl:    = %d\r\n", fm_rsq_status.afcrl);
//	LOG_I("fm_rsq_status.valid:    = %d\r\n", fm_rsq_status.valid);
//	LOG_I("fm_rsq_status.pilot:    = %d\r\n", fm_rsq_status.pilot);
//	LOG_I("fm_rsq_status.stblend:  = %d\r\n", fm_rsq_status.stblend);
//	LOG_I("fm_rsq_status.rssi:     = %d\r\n", fm_rsq_status.rssi);
//	LOG_I("fm_rsq_status.freq_off: = %d\r\n", fm_rsq_status.freq_off);
//	LOG_I("-------------------------------------------\r\n");
//}

///*
//************************************************************
//*	ƣ	si47xxFMRX_tune
//*
//*	ܣ	֪ĽƵν̨ܵϢ. 
//*
//*	ڲ	frequency Ƶ64-108MHz 10kHZΪ
//*
//*	ز	rssi
//*
//*	˵
//************************************************************
//*/
//u8 si47xxFMRX_tune(float frequency)
//{
//	u16 timeout=1000;
//	SeekTuneInProc = 1;               				// Enable the bit used for the interrupt of STC.
// 	WaitSTCInterrupt = 1;             				// Call the tune command to start the tune.
//	
//	while(--timeout&&!fmTuneFreq(frequency))		//ִָ  STCINTλ
//	{
//		Delay();
//	}	
//	if(timeout==0)
//	{
//		LOG_E("FM_TUNE_FREQʧ\r\n");
//		return 0;
//	}    
//    /*ڼ֮ǰȴжϣϣʹжϣϣѯò֣ע͸*/
//	//while (WaitSTCInterrupt); 					//ȴж

//    while (!(getIntStatus() & STCINT));   			//tune seekָҪȡSTCINT

//	timeout=1000;
//	while(--timeout&&!fmTuneStatus(0, 1))  			//ȡ״̬0STCINT λ
//	{
//		Delay();
//	}	
//	if(timeout==0)
//	{
//		LOG_E("FM_TUNE_FREQʧ\r\n");
//		return 0;
//	}    
//	
//	SeekTuneInProc = 0;      

//    return fm_tune_status.rssi;					  // RSSI 
//}

///*
//************************************************************
//*	ƣ	insert_preset
//*
//*	ܣ	ĵ̨Ϣ
//*
//*	ڲ	frequencyƵ rssiƵʵrssi  seek_preset_rssi:ƵʵrssiĽṹԱ
//*
//*	ز	
//*
//*	˵
//************************************************************
//*/
//static void insert_preset(float frequency, u8 rssi, u8 *seek_preset_rssi)
//{
//    u8 i;
//    u8 min_rssi = 0xff;
//    u8 min_rssi_preset = 0;

//    /*һҵСrssiλ*/ 
//    for ( i = 0; i < NUM_SEEK_PRESETS; i++ )
//    {
//        if(seek_preset_rssi[i] < min_rssi)
//        {
//            min_rssi = seek_preset_rssi[i];
//            min_rssi_preset = i;
//        }
//    }

//    /*ǰrssiССrssi*/ 
//    if(rssi < min_rssi)
//        return;

//    for ( i = min_rssi_preset; i < NUM_SEEK_PRESETS - 1; i++ )
//    {
//        fm_freq.seek_preset_freq[i] = fm_freq.seek_preset_freq[i + 1];
//        seek_preset_rssi[i] = seek_preset_rssi[i + 1];
//    }
//    fm_freq.seek_preset_freq[i] = 0;
//    seek_preset_rssi[i] = 0;

//    /*һΪ0λ*/
//    for ( i = min_rssi_preset; i < NUM_SEEK_PRESETS; i++ )
//    {
//        if(fm_freq.seek_preset_freq[i] == 0)
//        {
//            fm_freq.seek_preset_freq[i] = frequency;
//            seek_preset_rssi[i] = rssi;
//            break;
//        }
//    }
//}

///*
//************************************************************
//*	ƣ	si47xxFMRX_get_rssi
//*
//*	ܣ	ȡrssi
//*
//*	ڲ	
//*
//*	ز	rssi
//*
//*	˵
//************************************************************
//*/
//u8 si47xxFMRX_get_rssi()
//{
//	u16 timeout=1000;
//	
//	while(--timeout&&!fmTuneStatus(0,0)) 		
//	{
//		Delay();
//	}	
//	
//	if(timeout==0)
//	{
//		LOG_E("get_rssiʧ\r\n");
//		return 0;
//	}    

//    return fm_tune_status.rssi;
//}

///*
//************************************************************
//*	ƣ	si47xxFMRX_get_frequency
//*
//*	ܣ	ȡfrequency
//*
//*	ڲ	
//*
//*	ز	frequency
//*
//*	˵
//************************************************************
//*/
//float si47xxFMRX_get_frequency()
//{
//	u16 timeout=1000;
//	
//	while(--timeout&&!fmTuneStatus(0,0)) 		
//	{
//		Delay();
//	}	
//	
//	if(timeout==0)
//	{
//		LOG_E("get_frequencyʧ\r\n");
//		return 0;
//	}    
//	
//    return fm_tune_status.freq;
//}

///*
//************************************************************
//*	ƣ	fmSeekStart
//*
//*	ܣ	fmSeekStartʼƵ
//*
//*	ڲ	seekUp  wrapѭ
//*
//*	ز	0:ʧ   1ɹ
//*
//*	˵FM_SEEK_START=0x21
//************************************************************
//*/
//static uint8_t fmSeekStart(u8 seekUp, u8 wrap)
//{
//	u16 timeout=1000;
//    cmd[0] = FM_SEEK_START;

//	cmd[1] = 0;
//    if(seekUp) cmd[1] |= FM_SEEK_START_IN_SEEKUP;    //Ƶ
//	if(wrap)   cmd[1] |= FM_SEEK_START_IN_WRAP;      //ѭ

//	while(--timeout&&!si47xx_command(2, cmd, 1, rsp)) 	
//	{
//		Delay();
//	}	
//	
//	if(timeout==0)
//	{
//		LOG_E("FM_SEEK_STARTʧ\r\n");
//		return 0;
//	}    
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	si47xxFMRX_seek
//*
//*	ܣ	̨
//*
//*	ڲ	seekUp  seekmodeѭ
//*
//*	ز	1:ʧ   0ɹ   //
//*
//*	˵
//************************************************************
//*/
//u8 si47xxFMRX_seek(u8 seekup, u8 seekmode)
//{
//	u16 timeout=1000;
//	SeekTuneInProc = 1;				

// 	WaitSTCInterrupt = 1;			
//    fmSeekStart(seekup, !seekmode);

//	
//	
//	while(--timeout&&!fmSeekStart(seekup, !seekmode)) 	
//	{
//		Delay();
//	}	
//	
//	if(timeout==0)
//	{
//		LOG_E("FMRX_seekʧ\r\n");
//		autoseek_flag=1;
//		return 1;
//	}   
//	
//    /*ڼ֮ǰȴжϣϣʹжϣϣѯò֣ע͸*/
//	// while (WaitSTCInterrupt); 

//    /* ȴstcλλҪseekչڴѭеfmtunestatus
//	ԻõǰƵ,ڴ˵fmtunestatusʱȷIntackΪ.*/
//	
//    while (!(getIntStatus() & STCINT));

//	timeout=1000;
//	while(--timeout&&!fmTuneStatus(0, 1)) 	
//	{
//		Delay();
//	}	
//	
//	if(timeout==0)
//	{
//		LOG_E("FMRX_seekʧ\r\n");
//		autoseek_flag=1;
//		return 1;
//	}    

//	SeekTuneInProc = 0;				

//    return fm_tune_status.bltf; 
//}
//        

///*
//************************************************************
//*	ƣ	si47xxFMRX_autoseek
//*
//*	ܣ	ԶɨƵϢ
//*
//*	ڲ	
//*
//*	ز	
//*
//*	˵ɨ貨βʹòǿźseek_presets顣 
//*	δԤΣԤΪ㡣 ҪԤΪ㡣
//*	ע⣬autoseekڼ䣬ԽֵԤĻᡣ 
//*	ϵ͵ֵʱ䲢վյԤʱ϶ǽΪ㡣 
//*	ӦøıԤеĽ
//************************************************************
//*/
//uint8_t si47xxFMRX_autoseek(void)
//{
//    u8 i;
//    u8 seek_fail;
//    u8 num_found = 0;

//    for ( i = 0; i < NUM_SEEK_PRESETS; i++ ) 
//	{
//        fm_freq.seek_preset_rssi[i] = 0;
//        fm_freq.seek_preset_freq[i] = 0;
//    }
//	
//	// si47xxFMRX_mute(1);// Mute the audio
//	
//    si47xxFMRX_tune(76);								//ô76MHzʼɨ
//    seek_fail = si47xxFMRX_seek(1, 1);  				//seek up, stop at limits
//	if(autoseek_flag==1)
//	{
//		LOG_E("FMRX_autoseekʧ\r\n");
//	}
//	
//    while((seek_fail == 0)) 
//	{
//		insert_preset(fm_tune_status.freq, fm_tune_status.rssi, fm_freq.seek_preset_rssi);
//       
//		LOG_I("---------------̨Ϣ---------------\r\n");
//		LOG_I("FM̨:%2d\tƵ: %5d\tRSSI: %d\r\n",num_found + 1,fm_freq.seek_preset_freq[num_found],fm_freq.seek_preset_rssi[num_found]);
//		
//		seek_fail = si47xxFMRX_seek(1, 1); 			// seek up, stop at limts
//		if(autoseek_flag==1)
//		{
//			LOG_E("FMRX_autoseekδɳ\r\n");
//		}
//		num_found++;
//    }

//    //si47xxFMRX_tune(fm_freq.seek_preset_freq[0]);
//	//si47xxFMRX_mute(0);								// Unmute
//	
//	LOG_I("---------------̨ɨ---------------\r\n");
//    fm_freq.seek_fm_num = (num_found > NUM_SEEK_PRESETS) ? NUM_SEEK_PRESETS : num_found;
//	LOG_I("ɨ̨ܵ: %d\r\n", fm_freq.seek_fm_num);
//	
//	if(autoseek_flag==1)
//	{
//		LOG_E("ɨдɨ費\r\n");
//		autoseek_flag=0;
//		return 0;
//	}
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	si47xx_PowerUp
//*
//*	ܣ	ϵ
//*
//*	ڲ	
//*
//*	ز	0ϵʧ  1ϵɹ
//*
//*	˵POWER_UP=0x01 CTS interrupt enabled/GPO2 output enabled/
//*         Boot normally/Use crystal oscillator/Set to Analog Audio Output
//************************************************************
//*/
//uint8_t si47xx_PowerUp(void)
//{
//	u8 ucCmdBuf[3];
//	u16 uiTimeOut;
//	ucCmdBuf[0] = POWER_UP;       				//POWER_UP
//	ucCmdBuf[1] = 0xD0;          				//Set to FM Receive:Enable interrupts:CTS interrupt enabled/
//												//GPO2 output enabled/Boot normally/Use crystal oscillator
//	ucCmdBuf[2] = POWER_UP_IN_OPMODE_RX_ANALOG;	//Set to Analog Audio Output
//	si47xx_WriteReg(ucCmdBuf, 3);
//	uiTimeOut = si47xx_WaitStatus80(1000, 1);
//	if (uiTimeOut == 0)
//	{
//		return 0;
//	}
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	si47xx_PowerDown
//*
//*	ܣ	ȴӦϢ
//*
//*	ڲ	
//*
//*	ز	0ϵʧ  1ϵɹ
//*
//*	˵ POWER_DOWN=0x11
//************************************************************
//*/
//uint8_t si47xx_PowerDown(void)
//{
//	u8 ucCmdBuf[1];
//	u16 uiTimeOut;
//	ucCmdBuf[0] = POWER_DOWN;					//POWER_DOWN
//	si47xx_WriteReg(ucCmdBuf, 1);
//	uiTimeOut = si47xx_WaitStatus80(1000, 1);
//	if (uiTimeOut == 0)
//	{
//		return 0;
//	}
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	si47xx_Reset
//*
//*	ܣ	ģ鸴λŸλ
//*
//*	ڲ	
//*
//*	ز	
//*
//*	˵
//************************************************************
//*/
//void si47xx_Reset(void)
//{
//	si47xx_RESET_L;			
//	Delay();
//	si47xx_RESET_H;
//}


///*
//************************************************************
//*	ƣ	si47xx_Init
//*
//*	ܣ	ʼFMģ
//*
//*	ڲ	
//*
//*	ز	
//*
//*	˵ ģ鸴λ λ ϵ ȡ汾Ϣѡ á
//************************************************************
//*/
//void si47xx_Init(void)
//{	
//	u16 uiTimeOut=1000;
//	u8 buf[8];
//	
//	/*IIC1ųʼ*/
//	Si47xx_IIC_Init();
//	
//	/*si47xxRESET*/
//	si47xx_RESETGPIO_Config();			
//	
//	/*оƬsi47xxλ*/
//	si47xx_Reset();      
//	LOG_I("λ\r\n");	
//	
//	/*SI47xxϵ*/
//	while(--uiTimeOut&&!si47xx_PowerUp())			
//	{
//		Delay();
//	}
//	if(uiTimeOut==0)	
//	{
//		LOG_E("ϵʧ\r\n");
//		return;
//	}
//	power_up=1;
//	LOG_I("ϵ\r\n");
//	
//	/*ȡ汾Ϣ*/
//	uiTimeOut=1000;
//	while(--uiTimeOut&&!si47xx_GetRevision(buf)) 	
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("GetRevisionʧ\r\n");
//	}
//	else    				
//	{
//		LOG_I("---------------FMģ汾Ϣ---------------\r\n");
//		LOG_I("\tPart Number = %d\r\n\tFirmware Revision = %c%c\r\n\tPatch ID = 0x%02X%02X\r\n \
//		\tComponent Revision = 0x%c%c\r\n\tChip Revision = %c\r\n",buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);		
//	}
//	
//	/*˴ĬģʽҲSet GPO_IEN(property 0x0001)ʹRSQ InterruptRDS InterruptSTC Interruptж*/
//	
////	/*гƵʵȵֵʱƵս*/
////	si47xx_SoftMuteSet(64,0x0010,0x0004);										//ΪĬֵ(Զ)
////	
////	//si47xx_MonitorRSQSet(жԴжֵ);										// üźϢRSQ
////	
////	/*Ϊ(Ϊ0-63)*/
//	uiTimeOut=1000;
//	while(--uiTimeOut&&!si47xx_SetProperty(RX_VOLUME, RX_VOLUME_VOL_MAX)) 		//Ϊ(Ϊ0-63)
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set RX_VOLUMEʧ\r\n");
//	}
//	
//	/*  Ĭ0x0000 0x00020x0001ֱ*/
//	uiTimeOut=1000;
//	while(--uiTimeOut&&!si47xx_SetProperty(RX_HARD_MUTE, 0x0001)) 				//Ϊ(Ϊ0-63)
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set RX_HARD_MUTE ʧ\r\n");
//	}
//	
//	//while(!si47xx_SetProperty(FM_MAX_TUNE_ERROR, 0x001E));					//Ƶʴ  Ĭ0x001E  30kHz
//	
//	si47xxFMRX_tune(87.5);														//óʼƵ λMHz rssiֵ
//	
//	si47xxFMRX_autoseek();
//}

///*
//************************************************************
//*	ƣ	si47xx_WaitStatus80
//*
//*	ܣ	ȴӦϢ
//*
//*	ڲ	_uiTimeOutʱȴ  _ucStopEnֽڸ
//*
//*	ز	0ʱ  㣺سɹ
//*
//*	˵
//************************************************************
//*/
//u16 si47xx_WaitStatus80(u32 _uiTimeOut, u8 _ucStopEn)
//{
//	u8 ack;
//	u8 status;
//	u16 i;

//	/*ȴ״̬Ϊ80*/
//	for (i = 0; i < _uiTimeOut; i++)
//	{
//		Si47xx_IIC_Start();
//		ack = Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS+1);	// 

//		if (ack == 1)
//		{
//			Si47xx_IIC_NAck();
//			Si47xx_IIC_Stop();
//			return 0;	          							//Ӧʧ
//		}
//		status = Si47xx_I2C_RecvByte();
//		if ((status == 0x80) || (status == 0x81))			//0x81
//		{
//			break;
//		}
//	}
//	if (i == _uiTimeOut) 
//	{
//		Si47xx_IIC_NAck();
//		Si47xx_IIC_Stop();
//		return 0;											//ʱʧ
//	}

//	/*ɹˣһ1ξͳɹ */
//	if (i == 0)
//	{
//		i = 1;
//	}

//	if  (_ucStopEn == 1)
//	{
//		Si47xx_IIC_NAck();
//		Si47xx_IIC_Stop();
//	}
//	return i;
//}

///*
//************************************************************
//*	ƣ	si47xx_GetRevision
//*
//*	ܣ	ȡ汾Ϣ
//*
//*	ڲ	_ReadBuf洢صİ汾Ϣbuf
//*
//*	ز	0ȡʧ  1ȡɹ
//*
//*	˵	GET_REV=0x10  
//************************************************************
//*/
//uint8_t si47xx_GetRevision(uint8_t *_ReadBuf)
//{
//	u8 ucCmdBuf[2];
//	u16 uiTimeOut;
//	u8 i;

//	ucCmdBuf[0] = GET_REV;
//	si47xx_SendCmd(ucCmdBuf, 1);

//	uiTimeOut = si47xx_WaitStatus80(10, 0);
//	
//	if (uiTimeOut == 0)
//	{
//		return 0;
//	}
//	Si47xx_IIC_Ack();
//	for (i = 0; i < 8; i++)
//	{
//		_ReadBuf[i] = Si47xx_IIC_RecvByte(ACK);
//	}
//	Si47xx_IIC_NAck();
//	Si47xx_IIC_Stop();
//	
//	return 1;
//}


///*
//************************************************************
//*	ƣ	si47xx_SetProperty
//*
//*	ܣ	ָ
//*
//*	ڲ	_usPropNumberָ  _usPropValueõֵ
//*
//*	ز	0ʧ  1óɹ
//*
//*	˵	SET_PROPERTY=0x12  
//************************************************************
//*/
//uint8_t si47xx_SetProperty(uint16_t _usPropNumber, uint16_t _usPropValue)
//{
//	u8 ucCmdBuf[32];
//	u16 uiTimeOut;

//	ucCmdBuf[0] = SET_PROPERTY;
//	ucCmdBuf[1] = 0x00;

//	ucCmdBuf[2] = _usPropNumber >> 8;
//	ucCmdBuf[3] = _usPropNumber;

//	ucCmdBuf[4] = _usPropValue >> 8;
//	ucCmdBuf[5] = _usPropValue;
//	si47xx_SendCmd(ucCmdBuf, 6);

//	uiTimeOut = si47xx_WaitStatus80(100000, 1);
//	
//	if (uiTimeOut == 0)
//	{
//		return 0;
//	}

//	return 1;
//}
///*
//************************************************************
//*	ƣ	si47xx_GetProperty
//*
//*	ܣ	ȡָ״̬Ϣ
//*
//*	ڲ	_usPropNumberָ  _ReadBuf洢صֵbuf
//*
//*	ز	0ȡʧ  1ȡɹ
//*
//*	˵  GET_PROPERTY=0x13  3ֽڣһֽĬ0  23ֽΪЧֵ
//************************************************************
//*/
//uint8_t si47xx_GetProperty(uint16_t _usPropNumber,uint8_t *_ReadBuf)
//{
//	u8 i=0;
//	u8 ucCmdBuf[32];
//	u16 uiTimeOut;

//	ucCmdBuf[0] = GET_PROPERTY;
//	ucCmdBuf[1] = 0x00;

//	ucCmdBuf[2] = _usPropNumber >> 8;
//	ucCmdBuf[3] = _usPropNumber;
//	si47xx_SendCmd(ucCmdBuf, 4);
//	uiTimeOut = si47xx_WaitStatus80(100000, 1);

//	if (uiTimeOut == 0)
//	{
//		return 0;
//	}
//	Si47xx_IIC_Ack();
//	for (i = 0; i < 3; i++)
//	{
//		_ReadBuf[i] = Si47xx_IIC_RecvByte(ACK);
//	}
//	Si47xx_IIC_NAck();
//	Si47xx_IIC_Stop();
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	si47xx_SetFMFreq
//*
//*	ܣ	FMĲƵ
//*
//*	ڲ	_uiFreqõƵֵ
//*
//*	ز	0Ƶʧ  1Ƶʳɹ
//*
//*	˵	FM_TUNE_FREQ=0x20  ȡGET_INT_STATUS״̬
//************************************************************
//*/
//uint8_t si47xx_SetFMFreq(float _uiFreq)
//{
//	u8 ucCmdBuf[16];
//	u16 uiTimeOut;
//	u16 i,j;
//	u8 status;
//	u16 freq=0;
//	
//    freq=(u16)(_uiFreq*100);
//	ucCmdBuf[0] = FM_TUNE_FREQ;
//	ucCmdBuf[1] = 0x00;
//	ucCmdBuf[2] = freq >> 8;
//	ucCmdBuf[3] = freq;
//	ucCmdBuf[4] = 0x00;
//	si47xx_SendCmd(ucCmdBuf, 5);

//	uiTimeOut = si47xx_WaitStatus80(1000, 1);
//	if (uiTimeOut == 0)
//	{
//		return 0;
//	}

//	for (i = 0; i < 5000; i++)
//	{
//		ucCmdBuf[0] = GET_INT_STATUS;
//		si47xx_SendCmd(ucCmdBuf, 1);

//		for(j=0;j<1000;j++)
//		{
//			;
//		}
//		Si47xx_IIC_Start();
//		Si47xx_IIC_SendByte(si47xx_SLAVE_ADDRESS+1);	// 
//		Si47xx_IIC_WaitAck(10);
//		status = Si47xx_I2C_RecvByte();
//		Si47xx_IIC_Stop();
//		if (status == 0x81)
//		{
//			break;
//		}
//	}

//	if (i == 5000)
//	{
//		return 0;
//	}
//	
//	return 1;
//}
///*
//************************************************************
//*	ƣ	si47xx_GetRadioStatus
//*
//*	ܣ	ȡFM_TUNE_STATUS״̬
//*
//*	ڲ	ޣֵfm_tune_status_stṹ壩
//*
//*	ز	0ȡ״̬ʧ  1ȡ״̬ɹ
//*
//*	˵	FM_TUNE_STATUS=0x22  
//************************************************************
//*/
//uint8_t si47xx_GetRadioStatus(void)
//{
//	u16 uiTimeOut=1000;
//	
//	while(--uiTimeOut&&!fmTuneStatus(0,1));
//	if(uiTimeOut==0)
//	{
//		memset(&fm_tune_status,0,sizeof(fm_tune_status_st));
//		LOG_E("ȡTUNE״̬ϢʧܣЧTUNEϢ\r\n");
//		return 0;	
//	}
//	LOG_D("ȡTUNE״̬ϢɹЧTUNEϢ\r\n");
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	si47xx_ScanUpdateFMFreq
//*
//*	ܣ	ɨƵʲƵ
//*
//*	ڲ	
//*
//*	ز	
//*
//*	˵	
//************************************************************
//*/
//uint8_t si47xx_ScanUpdateFMFreq(void)
//{
//	return si47xxFMRX_autoseek();
//}

///*
//************************************************************
//*	ƣ	si47xx_MonitorRSQSet
//*
//*	ܣ	üźϢRSQ
//*
//*	ڲ	rsq_int_source:rsqжԴ  rsq_int_source_valueжԴ
//*
//*	ز	0:üRSQʧ   1:üRSQɹ
//*
//*	˵	
//************************************************************
//*/
//uint8_t si47xx_MonitorRSQSet(u16 rsq_int_source,u16 rsq_int_source_value)
//{
//	u16 uiTimeOut=1000;
//	
//	/*ʹRSQж,üźʹ*/
//	while(--uiTimeOut&&!si47xx_SetProperty(GPO_IEN, GPO_IEN_RSQIEN)) 			//ʹRSQж,üźʹ
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set GPO_IEN_RSQIENʧ\r\n");
//		return 0;
//	}
//	
//	/*üź*/
//	uiTimeOut=1000;
//	while(--uiTimeOut&&!si47xx_SetProperty(FM_RSQ_INT_SOURCE, rsq_int_source)) 	//źָصж
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set FM_RSQ_INT_SOURCEʧ\r\n");
//		return 0;
//	}
//	uiTimeOut=1000;
//	while(--uiTimeOut&&!si47xx_SetProperty(rsq_int_source, rsq_int_source_value))//жԴ
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set FM_RSQ_INT_SOURCE_VALUEʧ\r\n");
//		return 0;
//	}
//	
//	return 1;
//}

///*
//************************************************************
//*	ƣ	si47xx_MonitorRSQ
//*
//*	ܣ	ȡźżźϢRSQ
//*
//*	ڲ	
//*
//*	ز	0:ȡRSQʧ   1:ȡRSQɹ
//*
//*	˵	
//************************************************************
//*/
//uint8_t si47xx_FMRsqStatusMoniter()
//{
//	u16 uiTimeOut=1000;
//	
//	uiTimeOut=1000;
//	while(--uiTimeOut&&!fmRsqStatus(1))                     //ȡFM_RSQ_STATUSź
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		return 0;
//	}
//	
//	return 1;
//}


///*
//************************************************************
//*	ƣ	si47xx_SoftMuteSet
//*
//*	ܣ	
//*
//*	ڲ	value1FM_SOFT_MUTE_RATEֵ  
//*               value2FM_SOFT_MUTE_MAX_ATTENUATIONֵ
//*               value3FM_SOFT_MUTE_SNR_THRESHOLDֵ
//*
//*	ز	0:üRSQʧ   1:üRSQɹ
//*
//*	˵	
//************************************************************
//*/
//uint8_t si47xx_SoftMuteSet(u16 value1,u16 value2,u16 value3)
//{
//	u16 uiTimeOut=1000;
//	
//	/*гƵʵȵֵʱƵս*/
//	while(--uiTimeOut&&!si47xx_SetProperty(FM_SOFT_MUTE_RATE, value1)) 				// :1255 Ĭ64
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set FM_SOFT_MUTE_RATEʧ\r\n");
//		return 0;
//	}
//	
//	uiTimeOut=1000;
//	while(--uiTimeOut&&!si47xx_SetProperty(FM_SOFT_MUTE_MAX_ATTENUATION, value2)) 	//˥: 0C31 Ĭ0x0010
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set FM_SOFT_MUTE_MAX_ATTENUATIONʧ\r\n");
//		return 0;
//	}
//	uiTimeOut=1000;
//	
//	while(--uiTimeOut&&!si47xx_SetProperty(FM_SOFT_MUTE_SNR_THRESHOLD, value3)) 	//ýֵ : 0C15 Ĭ0x0004
//	{
//		Delay();
//	}	
//	if(uiTimeOut==0)
//	{
//		LOG_E("Set FM_SOFT_MUTE_SNR_THRESHOLDʧ\r\n");
//		return 0;
//	}
//	
//	return 1;
//}









